/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.206 Revision 1.421
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2013 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.206 2005/10/07 16:21:48 flameeyes Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.421 2013/05/22 05:10:29 mgorny Exp $
4#
5# Author: Martin Schlemmer <azarah@gentoo.org>
6#
7# This eclass is for general purpose functions that most ebuilds
8# have to implement themselves.
9#
10# NB: If you add anything, please comment it!
11 4
12inherit multilib portability 5# @ECLASS: eutils.eclass
6# @MAINTAINER:
7# base-system@gentoo.org
8# @BLURB: many extra (but common) functions that are used in ebuilds
9# @DESCRIPTION:
10# The eutils eclass contains a suite of functions that complement
11# the ones that ebuild.sh already contain. The idea is that the functions
12# are not required in all ebuilds but enough utilize them to have a common
13# home rather than having multiple ebuilds implementing the same thing.
14#
15# Due to the nature of this eclass, some functions may have maintainers
16# different from the overall eclass!
13 17
14DEPEND="!bootstrap? ( sys-devel/patch )" 18if [[ ${___ECLASS_ONCE_EUTILS} != "recur -_+^+_- spank" ]] ; then
15# sys-apps/shadow is needed for useradd, etc, bug #94745. 19___ECLASS_ONCE_EUTILS="recur -_+^+_- spank"
16 20
17DESCRIPTION="Based on the ${ECLASS} eclass" 21inherit multilib toolchain-funcs user
18 22
19# Wait for the supplied number of seconds. If no argument is supplied, defaults 23if has "${EAPI:-0}" 0 1 2; then
20# to five seconds. If the EPAUSE_IGNORE env var is set, don't wait. If we're not 24
21# outputting to a terminal, don't wait. For compatability purposes, the argument 25# @FUNCTION: epause
22# must be an integer greater than zero. 26# @USAGE: [seconds]
23# Bug 62950, Ciaran McCreesh <ciaranm@gentoo.org> (05 Sep 2004) 27# @DESCRIPTION:
28# Sleep for the specified number of seconds (default of 5 seconds). Useful when
29# printing a message the user should probably be reading and often used in
30# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set,
31# don't wait at all. Defined in EAPIs 0 1 and 2.
24epause() { 32epause() {
25 if [ -z "$EPAUSE_IGNORE" ] && [ -t 1 ] ; then 33 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
26 sleep ${1:-5}
27 fi
28} 34}
29 35
30# Beep the specified number of times (defaults to five). If our output 36# @FUNCTION: ebeep
31# is not a terminal, don't beep. If the EBEEP_IGNORE env var is set, 37# @USAGE: [number of beeps]
32# don't beep. 38# @DESCRIPTION:
33# Bug 62950, Ciaran McCreesh <ciaranm@gentoo.org> (05 Sep 2004) 39# Issue the specified number of beeps (default of 5 beeps). Useful when
40# printing a message the user should probably be reading and often used in
41# conjunction with the epause function. If the EBEEP_IGNORE env var is set,
42# don't beep at all. Defined in EAPIs 0 1 and 2.
34ebeep() { 43ebeep() {
35 local n 44 local n
36 if [ -z "$EBEEP_IGNORE" ] && [ -t 1 ] ; then 45 if [[ -z ${EBEEP_IGNORE} ]] ; then
37 for ((n=1 ; n <= ${1:-5} ; n++)) ; do 46 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
38 echo -ne "\a" 47 echo -ne "\a"
39 sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null 48 sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null
40 echo -ne "\a" 49 echo -ne "\a"
41 sleep 1 50 sleep 1
42 done 51 done
43 fi 52 fi
44} 53}
45 54
46# This function generate linker scripts in /usr/lib for dynamic 55else
47# libs in /lib. This is to fix linking problems when you have
48# the .so in /lib, and the .a in /usr/lib. What happens is that
49# in some cases when linking dynamic, the .a in /usr/lib is used
50# instead of the .so in /lib due to gcc/libtool tweaking ld's
51# library search path. This cause many builds to fail.
52# See bug #4411 for more info.
53#
54# To use, simply call:
55#
56# gen_usr_ldscript libfoo.so
57#
58# Note that you should in general use the unversioned name of
59# the library, as ldconfig should usually update it correctly
60# to point to the latest version of the library present.
61#
62# <azarah@gentoo.org> (26 Oct 2002)
63#
64gen_usr_ldscript() {
65 local libdir="$(get_libdir)"
66 # Just make sure it exists
67 dodir /usr/${libdir}
68 56
69 for lib in "${@}" ; do 57ebeep() {
70 cat > "${D}/usr/${libdir}/${lib}" <<-END_LDSCRIPT 58 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
71 /* GNU ld script 59}
72 Since Gentoo has critical dynamic libraries
73 in /lib, and the static versions in /usr/lib,
74 we need to have a "fake" dynamic lib in /usr/lib,
75 otherwise we run into linking problems.
76 60
77 See bug http://bugs.gentoo.org/4411 for more info. 61epause() {
78 */ 62 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
79 GROUP ( /${libdir}/${lib} ) 63}
80 END_LDSCRIPT 64
81 fperms a+x "/usr/${libdir}/${lib}" 65fi
66
67# @FUNCTION: eqawarn
68# @USAGE: [message]
69# @DESCRIPTION:
70# Proxy to ewarn for package managers that don't provide eqawarn and use the PM
71# implementation if available. Reuses PORTAGE_ELOG_CLASSES as set by the dev
72# profile.
73if ! declare -F eqawarn >/dev/null ; then
74 eqawarn() {
75 has qa ${PORTAGE_ELOG_CLASSES} && ewarn "$@"
76 :
77 }
78fi
79
80# @FUNCTION: ecvs_clean
81# @USAGE: [list of dirs]
82# @DESCRIPTION:
83# Remove CVS directories recursiveley. Useful when a source tarball contains
84# internal CVS directories. Defaults to $PWD.
85ecvs_clean() {
86 [[ -z $* ]] && set -- .
87 find "$@" -type d -name 'CVS' -prune -print0 | xargs -0 rm -rf
88 find "$@" -type f -name '.cvs*' -print0 | xargs -0 rm -rf
89}
90
91# @FUNCTION: esvn_clean
92# @USAGE: [list of dirs]
93# @DESCRIPTION:
94# Remove .svn directories recursiveley. Useful when a source tarball contains
95# internal Subversion directories. Defaults to $PWD.
96esvn_clean() {
97 [[ -z $* ]] && set -- .
98 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
99}
100
101# @FUNCTION: estack_push
102# @USAGE: <stack> [items to push]
103# @DESCRIPTION:
104# Push any number of items onto the specified stack. Pick a name that
105# is a valid variable (i.e. stick to alphanumerics), and push as many
106# items as you like onto the stack at once.
107#
108# The following code snippet will echo 5, then 4, then 3, then ...
109# @CODE
110# estack_push mystack 1 2 3 4 5
111# while estack_pop mystack i ; do
112# echo "${i}"
82 done 113# done
114# @CODE
115estack_push() {
116 [[ $# -eq 0 ]] && die "estack_push: incorrect # of arguments"
117 local stack_name="__ESTACK_$1__" ; shift
118 eval ${stack_name}+=\( \"\$@\" \)
83} 119}
84 120
85# Simple function to draw a line consisting of '=' the same length as $* 121# @FUNCTION: estack_pop
86# - only to be used by epatch() 122# @USAGE: <stack> [variable]
87# 123# @DESCRIPTION:
88# <azarah@gentoo.org> (11 Nov 2002) 124# Pop a single item off the specified stack. If a variable is specified,
89# 125# the popped item is stored there. If no more items are available, return
90draw_line() { 126# 1, else return 0. See estack_push for more info.
91 local i=0 127estack_pop() {
92 local str_length="" 128 [[ $# -eq 0 || $# -gt 2 ]] && die "estack_pop: incorrect # of arguments"
93 129
94 # Handle calls that do not have args, or wc not being installed ... 130 # We use the fugly __estack_xxx var names to avoid collision with
95 if [ -z "$1" -o ! -x "$(which wc 2>/dev/null)" ] 131 # passing back the return value. If we used "local i" and the
96 then 132 # caller ran `estack_pop ... i`, we'd end up setting the local
97 echo "===============================================================" 133 # copy of "i" rather than the caller's copy. The __estack_xxx
134 # garbage is preferable to using $1/$2 everywhere as that is a
135 # bit harder to read.
136 local __estack_name="__ESTACK_$1__" ; shift
137 local __estack_retvar=$1 ; shift
138 eval local __estack_i=\${#${__estack_name}\[@\]}
139 # Don't warn -- let the caller interpret this as a failure
140 # or as normal behavior (akin to `shift`)
141 [[ $(( --__estack_i )) -eq -1 ]] && return 1
142
143 if [[ -n ${__estack_retvar} ]] ; then
144 eval ${__estack_retvar}=\"\${${__estack_name}\[${__estack_i}\]}\"
145 fi
146 eval unset ${__estack_name}\[${__estack_i}\]
147}
148
149# @FUNCTION: eshopts_push
150# @USAGE: [options to `set` or `shopt`]
151# @DESCRIPTION:
152# Often times code will want to enable a shell option to change code behavior.
153# Since changing shell options can easily break other pieces of code (which
154# assume the default state), eshopts_push is used to (1) push the current shell
155# options onto a stack and (2) pass the specified arguments to set.
156#
157# If the first argument is '-s' or '-u', we assume you want to call `shopt`
158# rather than `set` as there are some options only available via that.
159#
160# A common example is to disable shell globbing so that special meaning/care
161# may be used with variables/arguments to custom functions. That would be:
162# @CODE
163# eshopts_push -s noglob
164# for x in ${foo} ; do
165# if ...some check... ; then
166# eshopts_pop
98 return 0 167# return 0
99 fi 168# fi
100
101 # Get the length of $*
102 str_length="$(echo -n "$*" | wc -m)"
103
104 while [ "$i" -lt "${str_length}" ]
105 do
106 echo -n "="
107
108 i=$((i + 1))
109 done 169# done
110 170# eshopts_pop
111 echo 171# @CODE
112 172eshopts_push() {
113 return 0 173 if [[ $1 == -[su] ]] ; then
174 estack_push eshopts "$(shopt -p)"
175 [[ $# -eq 0 ]] && return 0
176 shopt "$@" || die "${FUNCNAME}: bad options to shopt: $*"
177 else
178 estack_push eshopts $-
179 [[ $# -eq 0 ]] && return 0
180 set "$@" || die "${FUNCNAME}: bad options to set: $*"
181 fi
114} 182}
115 183
116# Default directory where patches are located 184# @FUNCTION: eshopts_pop
185# @USAGE:
186# @DESCRIPTION:
187# Restore the shell options to the state saved with the corresponding
188# eshopts_push call. See that function for more details.
189eshopts_pop() {
190 local s
191 estack_pop eshopts s || die "${FUNCNAME}: unbalanced push"
192 if [[ ${s} == "shopt -"* ]] ; then
193 eval "${s}" || die "${FUNCNAME}: sanity: invalid shopt options: ${s}"
194 else
195 set +$- || die "${FUNCNAME}: sanity: invalid shell settings: $-"
196 set -${s} || die "${FUNCNAME}: sanity: unable to restore saved shell settings: ${s}"
197 fi
198}
199
200# @FUNCTION: eumask_push
201# @USAGE: <new umask>
202# @DESCRIPTION:
203# Set the umask to the new value specified while saving the previous
204# value onto a stack. Useful for temporarily changing the umask.
205eumask_push() {
206 estack_push eumask "$(umask)"
207 umask "$@" || die "${FUNCNAME}: bad options to umask: $*"
208}
209
210# @FUNCTION: eumask_pop
211# @USAGE:
212# @DESCRIPTION:
213# Restore the previous umask state.
214eumask_pop() {
215 [[ $# -eq 0 ]] || die "${FUNCNAME}: we take no options"
216 local s
217 estack_pop eumask s || die "${FUNCNAME}: unbalanced push"
218 umask ${s} || die "${FUNCNAME}: sanity: could not restore umask: ${s}"
219}
220
221# @VARIABLE: EPATCH_SOURCE
222# @DESCRIPTION:
223# Default directory to search for patches.
117EPATCH_SOURCE="${WORKDIR}/patch" 224EPATCH_SOURCE="${WORKDIR}/patch"
118# Default extension for patches 225# @VARIABLE: EPATCH_SUFFIX
226# @DESCRIPTION:
227# Default extension for patches (do not prefix the period yourself).
119EPATCH_SUFFIX="patch.bz2" 228EPATCH_SUFFIX="patch.bz2"
120# Default options for patch 229# @VARIABLE: EPATCH_OPTS
230# @DESCRIPTION:
231# Options to pass to patch. Meant for ebuild/package-specific tweaking
232# such as forcing the patch level (-p#) or fuzz (-F#) factor. Note that
233# for single patch tweaking, you can also pass flags directly to epatch.
234EPATCH_OPTS=""
235# @VARIABLE: EPATCH_COMMON_OPTS
236# @DESCRIPTION:
237# Common options to pass to `patch`. You probably should never need to
238# change these. If you do, please discuss it with base-system first to
239# be sure.
240# @CODE
121# Set -g0 to keep RCS, ClearCase, Perforce and SCCS happy. Bug #24571 241# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
122# Set --no-backup-if-mismatch so we don't leave '.orig' files behind. 242# --no-backup-if-mismatch - do not leave .orig files behind
243# -E - automatically remove empty files
244# @CODE
123EPATCH_OPTS="-g0 --no-backup-if-mismatch" 245EPATCH_COMMON_OPTS="-g0 -E --no-backup-if-mismatch"
246# @VARIABLE: EPATCH_EXCLUDE
247# @DESCRIPTION:
124# List of patches not to apply. Not this is only file names, 248# List of patches not to apply. Note this is only file names,
125# and not the full path .. 249# and not the full path. Globs accepted.
126EPATCH_EXCLUDE="" 250EPATCH_EXCLUDE=""
251# @VARIABLE: EPATCH_SINGLE_MSG
252# @DESCRIPTION:
127# Change the printed message for a single patch. 253# Change the printed message for a single patch.
128EPATCH_SINGLE_MSG="" 254EPATCH_SINGLE_MSG=""
255# @VARIABLE: EPATCH_MULTI_MSG
256# @DESCRIPTION:
129# Change the printed message for multiple patches. 257# Change the printed message for multiple patches.
130EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..." 258EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
131# Force applying bulk patches even if not following the style: 259# @VARIABLE: EPATCH_FORCE
132# 260# @DESCRIPTION:
133# ??_${ARCH}_foo.${EPATCH_SUFFIX} 261# Only require patches to match EPATCH_SUFFIX rather than the extended
134# 262# arch naming style.
135EPATCH_FORCE="no" 263EPATCH_FORCE="no"
264# @VARIABLE: EPATCH_USER_EXCLUDE
265# @DEFAULT_UNSET
266# @DESCRIPTION:
267# List of patches not to apply. Note this is only file names,
268# and not the full path. Globs accepted.
136 269
137# This function is for bulk patching, or in theory for just one 270# @FUNCTION: epatch
138# or two patches. 271# @USAGE: [options] [patches] [dirs of patches]
272# @DESCRIPTION:
273# epatch is designed to greatly simplify the application of patches. It can
274# process patch files directly, or directories of patches. The patches may be
275# compressed (bzip/gzip/etc...) or plain text. You generally need not specify
276# the -p option as epatch will automatically attempt -p0 to -p5 until things
277# apply successfully.
139# 278#
140# It should work with .bz2, .gz, .zip and plain text patches. 279# If you do not specify any patches/dirs, then epatch will default to the
141# Currently all patches should be the same format. 280# directory specified by EPATCH_SOURCE.
142# 281#
143# You do not have to specify '-p' option to patch, as it will 282# Any options specified that start with a dash will be passed down to patch
144# try with -p0 to -p5 until it succeed, or fail at -p5. 283# for this specific invocation. As soon as an arg w/out a dash is found, then
284# arg processing stops.
145# 285#
146# Above EPATCH_* variables can be used to control various defaults, 286# When processing directories, epatch will apply all patches that match:
147# bug they should be left as is to ensure an ebuild can rely on 287# @CODE
148# them for. 288# if ${EPATCH_FORCE} != "yes"
149#
150# Patches are applied in current directory.
151#
152# Bulk Patches should preferibly have the form of:
153#
154# ??_${ARCH}_foo.${EPATCH_SUFFIX} 289# ??_${ARCH}_foo.${EPATCH_SUFFIX}
290# else
291# *.${EPATCH_SUFFIX}
292# @CODE
293# The leading ?? are typically numbers used to force consistent patch ordering.
294# The arch field is used to apply patches only for the host architecture with
295# the special value of "all" means apply for everyone. Note that using values
296# other than "all" is highly discouraged -- you should apply patches all the
297# time and let architecture details be detected at configure/compile time.
155# 298#
156# For example: 299# If EPATCH_SUFFIX is empty, then no period before it is implied when searching
300# for patches to apply.
157# 301#
158# 01_all_misc-fix.patch.bz2 302# Refer to the other EPATCH_xxx variables for more customization of behavior.
159# 02_sparc_another-fix.patch.bz2
160#
161# This ensures that there are a set order, and you can have ARCH
162# specific patches.
163#
164# If you however give an argument to epatch(), it will treat it as a
165# single patch that need to be applied if its a file. If on the other
166# hand its a directory, it will set EPATCH_SOURCE to this.
167#
168# <azarah@gentoo.org> (10 Nov 2002)
169#
170epatch() { 303epatch() {
171 local PIPE_CMD="" 304 _epatch_draw_line() {
172 local STDERR_TARGET="${T}/$$.out" 305 # create a line of same length as input string
173 local PATCH_TARGET="${T}/$$.patch" 306 [[ -z $1 ]] && set "$(printf "%65s" '')"
174 local PATCH_SUFFIX="" 307 echo "${1//?/=}"
175 local SINGLE_PATCH="no" 308 }
176 local x=""
177 309
178 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402 310 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
179 311
180 if [ "$#" -gt 1 ] 312 # First process options. We localize the EPATCH_OPTS setting
181 then 313 # from above so that we can pass it on in the loop below with
314 # any additional values the user has specified.
315 local EPATCH_OPTS=( ${EPATCH_OPTS[*]} )
316 while [[ $# -gt 0 ]] ; do
317 case $1 in
318 -*) EPATCH_OPTS+=( "$1" ) ;;
319 *) break ;;
320 esac
321 shift
322 done
323
324 # Let the rest of the code process one user arg at a time --
325 # each arg may expand into multiple patches, and each arg may
326 # need to start off with the default global EPATCH_xxx values
327 if [[ $# -gt 1 ]] ; then
182 local m="" 328 local m
183 for m in "$@" ; do 329 for m in "$@" ; do
184 epatch "${m}" 330 epatch "${m}"
185 done 331 done
186 return 0 332 return 0
187 fi 333 fi
188 334
189 if [ -n "$1" -a -f "$1" ] 335 local SINGLE_PATCH="no"
190 then 336 # no args means process ${EPATCH_SOURCE}
337 [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
338
339 if [[ -f $1 ]] ; then
191 SINGLE_PATCH="yes" 340 SINGLE_PATCH="yes"
192 341 set -- "$1"
193 local EPATCH_SOURCE="$1" 342 # Use the suffix from the single patch (localize it); the code
343 # below will find the suffix for us
194 local EPATCH_SUFFIX="${1##*\.}" 344 local EPATCH_SUFFIX=$1
195 345
196 elif [ -n "$1" -a -d "$1" ] 346 elif [[ -d $1 ]] ; then
197 then 347 # Some people like to make dirs of patches w/out suffixes (vim)
198 # Allow no extension if EPATCH_FORCE=yes ... used by vim for example ... 348 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
199 if [ "${EPATCH_FORCE}" = "yes" ] && [ -z "${EPATCH_SUFFIX}" ] 349
350 elif [[ -f ${EPATCH_SOURCE}/$1 ]] ; then
351 # Re-use EPATCH_SOURCE as a search dir
352 epatch "${EPATCH_SOURCE}/$1"
353 return $?
354
355 else
356 # sanity check ... if it isn't a dir or file, wtf man ?
357 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
358 echo
359 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
360 eerror
361 eerror " ${EPATCH_SOURCE}"
362 eerror " ( ${EPATCH_SOURCE##*/} )"
363 echo
364 die "Cannot find \$EPATCH_SOURCE!"
365 fi
366
367 # Now that we know we're actually going to apply something, merge
368 # all of the patch options back in to a single variable for below.
369 EPATCH_OPTS="${EPATCH_COMMON_OPTS} ${EPATCH_OPTS[*]}"
370
371 local PIPE_CMD
372 case ${EPATCH_SUFFIX##*\.} in
373 xz) PIPE_CMD="xz -dc" ;;
374 lzma) PIPE_CMD="lzma -dc" ;;
375 bz2) PIPE_CMD="bzip2 -dc" ;;
376 gz|Z|z) PIPE_CMD="gzip -dc" ;;
377 ZIP|zip) PIPE_CMD="unzip -p" ;;
378 *) ;;
379 esac
380
381 [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
382
383 local x
384 for x in "$@" ; do
385 # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
386 # didn't match anything, ignore continue on
387 [[ ! -f ${x} ]] && continue
388
389 local patchname=${x##*/}
390
391 # Apply single patches, or forced sets of patches, or
392 # patches with ARCH dependant names.
393 # ???_arch_foo.patch
394 # Else, skip this input altogether
395 local a=${patchname#*_} # strip the ???_
396 a=${a%%_*} # strip the _foo.patch
397 if ! [[ ${SINGLE_PATCH} == "yes" || \
398 ${EPATCH_FORCE} == "yes" || \
399 ${a} == all || \
400 ${a} == ${ARCH} ]]
200 then 401 then
201 local EPATCH_SOURCE="$1/*" 402 continue
403 fi
404
405 # Let people filter things dynamically
406 if [[ -n ${EPATCH_EXCLUDE} ]] ; then
407 # let people use globs in the exclude
408 eshopts_push -o noglob
409
410 local ex
411 for ex in ${EPATCH_EXCLUDE} ; do
412 if [[ ${patchname} == ${ex} ]] ; then
413 einfo " Skipping ${patchname} due to EPATCH_EXCLUDE ..."
414 eshopts_pop
415 continue 2
416 fi
417 done
418
419 for ex in ${EPATCH_USER_EXCLUDE} ; do
420 if [[ ${patchname} == ${ex} ]] ; then
421 einfo " Skipping ${patchname} due to EPATCH_USER_EXCLUDE ..."
422 eshopts_pop
423 continue 2
424 fi
425 done
426
427 eshopts_pop
428 fi
429
430 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
431 if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
432 einfo "${EPATCH_SINGLE_MSG}"
433 else
434 einfo "Applying ${patchname} ..."
435 fi
202 else 436 else
203 local EPATCH_SOURCE="$1/*.${EPATCH_SUFFIX}" 437 einfo " ${patchname} ..."
204 fi 438 fi
205 else 439
206 if [ ! -d ${EPATCH_SOURCE} ] || [ -n "$1" ] 440 # most of the time, there will only be one run per unique name,
207 then 441 # but if there are more, make sure we get unique log filenames
208 if [ -n "$1" -a "${EPATCH_SOURCE}" = "${WORKDIR}/patch" ] 442 local STDERR_TARGET="${T}/${patchname}.out"
209 then 443 if [[ -e ${STDERR_TARGET} ]] ; then
210 EPATCH_SOURCE="$1" 444 STDERR_TARGET="${T}/${patchname}-$$.out"
445 fi
446
447 printf "***** %s *****\nPWD: %s\n\n" "${patchname}" "${PWD}" > "${STDERR_TARGET}"
448
449 # Decompress the patch if need be
450 local count=0
451 local PATCH_TARGET
452 if [[ -n ${PIPE_CMD} ]] ; then
453 PATCH_TARGET="${T}/$$.patch"
454 echo "PIPE_COMMAND: ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
455
456 if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
457 echo
458 eerror "Could not extract patch!"
459 #die "Could not extract patch!"
460 count=5
461 break
211 fi 462 fi
463 else
464 PATCH_TARGET=${x}
465 fi
212 466
467 # Check for absolute paths in patches. If sandbox is disabled,
468 # people could (accidently) patch files in the root filesystem.
469 # Or trigger other unpleasantries #237667. So disallow -p0 on
470 # such patches.
471 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
472 if [[ -n ${abs_paths} ]] ; then
473 count=1
474 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
475 fi
476 # Similar reason, but with relative paths.
477 local rel_paths=$(egrep -n '^[-+]{3} [^ ]*[.][.]/' "${PATCH_TARGET}")
478 if [[ -n ${rel_paths} ]] ; then
213 echo 479 echo
214 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:" 480 eerror "Rejected Patch: ${patchname} !"
481 eerror " ( ${PATCH_TARGET} )"
215 eerror 482 eerror
216 eerror " ${EPATCH_SOURCE}" 483 eerror "Your patch uses relative paths '../':"
217 eerror " ( ${EPATCH_SOURCE##*/} )" 484 eerror "${rel_paths}"
218 echo 485 echo
219 die "Cannot find \$EPATCH_SOURCE!" 486 die "you need to fix the relative paths in patch"
220 fi
221
222 local EPATCH_SOURCE="${EPATCH_SOURCE}/*.${EPATCH_SUFFIX}"
223 fi 487 fi
224 488
225 case ${EPATCH_SUFFIX##*\.} in 489 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
226 bz2) 490 local patch_cmd
227 PIPE_CMD="bzip2 -dc" 491 # Handle aliased patch command #404447 #461568
228 PATCH_SUFFIX="bz2" 492 local patch="patch"
229 ;; 493 eval $(alias patch 2>/dev/null | sed 's:^alias ::')
230 gz|Z|z) 494 while [[ ${count} -lt 5 ]] ; do
231 PIPE_CMD="gzip -dc" 495 patch_cmd="${patch} -p${count} ${EPATCH_OPTS}"
232 PATCH_SUFFIX="gz"
233 ;;
234 ZIP|zip)
235 PIPE_CMD="unzip -p"
236 PATCH_SUFFIX="zip"
237 ;;
238 *)
239 PIPE_CMD="cat"
240 PATCH_SUFFIX="patch"
241 ;;
242 esac
243 496
244 if [ "${SINGLE_PATCH}" = "no" ] 497 # Generate some useful debug info ...
245 then 498 (
246 einfo "${EPATCH_MULTI_MSG}" 499 _epatch_draw_line "***** ${patchname} *****"
247 fi 500 echo
248 for x in ${EPATCH_SOURCE} 501 echo "PATCH COMMAND: ${patch_cmd} < '${PATCH_TARGET}'"
249 do 502 echo
250 # New ARCH dependant patch naming scheme ... 503 _epatch_draw_line "***** ${patchname} *****"
251 # 504 ${patch_cmd} --dry-run -f < "${PATCH_TARGET}" 2>&1
252 # ???_arch_foo.patch 505 ret=$?
253 # 506 echo
254 if [ -f ${x} ] && \ 507 echo "patch program exited with status ${ret}"
255 ([ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "${x/_${ARCH}_}" != "${x}" ] || \ 508 exit ${ret}
256 [ "${EPATCH_FORCE}" = "yes" ]) 509 ) >> "${STDERR_TARGET}"
257 then
258 local count=0
259 local popts="${EPATCH_OPTS}"
260 local patchname=${x##*/}
261 510
262 if [ -n "${EPATCH_EXCLUDE}" ] 511 if [ $? -eq 0 ] ; then
263 then 512 (
264 if [ "${EPATCH_EXCLUDE/${patchname}}" != "${EPATCH_EXCLUDE}" ] 513 _epatch_draw_line "***** ${patchname} *****"
265 then 514 echo
266 continue 515 echo "ACTUALLY APPLYING ${patchname} ..."
516 echo
517 _epatch_draw_line "***** ${patchname} *****"
518 ${patch_cmd} < "${PATCH_TARGET}" 2>&1
519 ret=$?
520 echo
521 echo "patch program exited with status ${ret}"
522 exit ${ret}
523 ) >> "${STDERR_TARGET}"
524
525 if [ $? -ne 0 ] ; then
526 echo
527 eerror "A dry-run of patch command succeeded, but actually"
528 eerror "applying the patch failed!"
529 #die "Real world sux compared to the dreamworld!"
530 count=5
267 fi 531 fi
532 break
268 fi 533 fi
269 534
270 if [ "${SINGLE_PATCH}" = "yes" ] 535 : $(( count++ ))
271 then
272 if [ -n "${EPATCH_SINGLE_MSG}" ]
273 then
274 einfo "${EPATCH_SINGLE_MSG}"
275 else
276 einfo "Applying ${patchname} ..."
277 fi
278 else
279 einfo " ${patchname} ..."
280 fi
281
282 echo "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
283 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
284
285 # Allow for prefix to differ ... im lazy, so shoot me :/
286 while [ "${count}" -lt 5 ]
287 do
288 # Generate some useful debug info ...
289 draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
290 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
291
292 if [ "${PATCH_SUFFIX}" != "patch" ]
293 then
294 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
295 echo "${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
296 else
297 PATCH_TARGET="${x}"
298 fi
299
300 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
301 echo "patch -p${count} ${popts} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
302
303 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
304 draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
305
306 if [ "${PATCH_SUFFIX}" != "patch" ]
307 then
308 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
309 then
310 echo
311 eerror "Could not extract patch!"
312 #die "Could not extract patch!"
313 count=5
314 break
315 fi
316 fi
317
318 if (cat ${PATCH_TARGET} | patch -p${count} ${popts} --dry-run -f) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
319 then
320 draw_line "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
321 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
322 echo "ACTUALLY APPLYING ${patchname} ..." >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
323 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
324 draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
325
326 cat ${PATCH_TARGET} | patch -p${count} ${popts} >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 2>&1
327
328 if [ "$?" -ne 0 ]
329 then
330 cat ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
331 echo
332 eerror "A dry-run of patch command succeeded, but actually"
333 eerror "applying the patch failed!"
334 #die "Real world sux compared to the dreamworld!"
335 count=5
336 fi
337
338 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
339
340 break
341 fi
342
343 count=$((count + 1))
344 done 536 done
345 537
346 if [ "${PATCH_SUFFIX}" != "patch" ] 538 # if we had to decompress the patch, delete the temp one
347 then 539 if [[ -n ${PIPE_CMD} ]] ; then
348 rm -f ${PATCH_TARGET} 540 rm -f "${PATCH_TARGET}"
349 fi 541 fi
350 542
351 if [ "${count}" -eq 5 ] 543 if [[ ${count} -ge 5 ]] ; then
352 then
353 echo 544 echo
354 eerror "Failed Patch: ${patchname} !" 545 eerror "Failed Patch: ${patchname} !"
355 eerror " ( ${PATCH_TARGET} )" 546 eerror " ( ${PATCH_TARGET} )"
356 eerror 547 eerror
357 eerror "Include in your bugreport the contents of:" 548 eerror "Include in your bugreport the contents of:"
358 eerror 549 eerror
359 eerror " ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}" 550 eerror " ${STDERR_TARGET}"
360 echo 551 echo
361 die "Failed Patch: ${patchname}!" 552 die "Failed Patch: ${patchname}!"
362 fi 553 fi
363 554
364 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 555 # if everything worked, delete the full debug patch log
556 rm -f "${STDERR_TARGET}"
365 557
558 # then log away the exact stuff for people to review later
559 cat <<-EOF >> "${T}/epatch.log"
560 PATCH: ${x}
561 CMD: ${patch_cmd}
562 PWD: ${PWD}
563
564 EOF
366 eend 0 565 eend 0
367 fi
368 done 566 done
369 if [ "${SINGLE_PATCH}" = "no" ] 567
370 then 568 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
371 einfo "Done with patching" 569 : # everything worked
570}
571
572# @FUNCTION: epatch_user
573# @USAGE:
574# @DESCRIPTION:
575# Applies user-provided patches to the source tree. The patches are
576# taken from /etc/portage/patches/<CATEGORY>/<PF|P|PN>[:SLOT]/, where the first
577# of these three directories to exist will be the one to use, ignoring
578# any more general directories which might exist as well. They must end
579# in ".patch" to be applied.
580#
581# User patches are intended for quick testing of patches without ebuild
582# modifications, as well as for permanent customizations a user might
583# desire. Obviously, there can be no official support for arbitrarily
584# patched ebuilds. So whenever a build log in a bug report mentions that
585# user patches were applied, the user should be asked to reproduce the
586# problem without these.
587#
588# Not all ebuilds do call this function, so placing patches in the
589# stated directory might or might not work, depending on the package and
590# the eclasses it inherits and uses. It is safe to call the function
591# repeatedly, so it is always possible to add a call at the ebuild
592# level. The first call is the time when the patches will be
593# applied.
594#
595# Ideally, this function should be called after gentoo-specific patches
596# have been applied, so that their code can be modified as well, but
597# before calls to e.g. eautoreconf, as the user patches might affect
598# autotool input files as well.
599epatch_user() {
600 [[ $# -ne 0 ]] && die "epatch_user takes no options"
601
602 # Allow multiple calls to this function; ignore all but the first
603 local applied="${T}/epatch_user.log"
604 [[ -e ${applied} ]] && return 2
605
606 # don't clobber any EPATCH vars that the parent might want
607 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
608 for check in ${CATEGORY}/{${P}-${PR},${P},${PN}}{,:${SLOT}}; do
609 EPATCH_SOURCE=${base}/${CTARGET}/${check}
610 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
611 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
612 if [[ -d ${EPATCH_SOURCE} ]] ; then
613 EPATCH_SOURCE=${EPATCH_SOURCE} \
614 EPATCH_SUFFIX="patch" \
615 EPATCH_FORCE="yes" \
616 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
617 epatch
618 echo "${EPATCH_SOURCE}" > "${applied}"
619 return 0
372 fi 620 fi
621 done
622 echo "none" > "${applied}"
623 return 1
373} 624}
374 625
626# @FUNCTION: emktemp
627# @USAGE: [temp dir]
628# @DESCRIPTION:
375# Cheap replacement for when debianutils (and thus mktemp) 629# Cheap replacement for when debianutils (and thus mktemp)
376# does not exist on the users system 630# does not exist on the users system.
377# vapier@gentoo.org
378#
379# Takes just 1 optional parameter (the directory to create tmpfile in)
380emktemp() { 631emktemp() {
381 local exe="touch" 632 local exe="touch"
382 [[ $1 == -d ]] && exe="mkdir" && shift 633 [[ $1 == -d ]] && exe="mkdir" && shift
383 local topdir=$1 634 local topdir=$1
384 635
386 [[ -z ${T} ]] \ 637 [[ -z ${T} ]] \
387 && topdir="/tmp" \ 638 && topdir="/tmp" \
388 || topdir=${T} 639 || topdir=${T}
389 fi 640 fi
390 641
391 if [[ -z $(type -p mktemp) ]] ; then 642 if ! type -P mktemp > /dev/null ; then
643 # system lacks `mktemp` so we have to fake it
392 local tmp=/ 644 local tmp=/
393 while [[ -e ${tmp} ]] ; do 645 while [[ -e ${tmp} ]] ; do
394 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM} 646 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}
395 done 647 done
396 ${exe} "${tmp}" || ${exe} -p "${tmp}" 648 ${exe} "${tmp}" || ${exe} -p "${tmp}"
397 echo "${tmp}" 649 echo "${tmp}"
398 else 650 else
651 # the args here will give slightly wierd names on BSD,
652 # but should produce a usable file on all userlands
399 [[ ${exe} == "touch" ]] \ 653 if [[ ${exe} == "touch" ]] ; then
400 && exe="-p" \ 654 TMPDIR="${topdir}" mktemp -t tmp.XXXXXXXXXX
401 || exe="-d"
402 mktemp ${exe} "${topdir}"
403 fi
404}
405
406# Small wrapper for getent (Linux), nidump (Mac OS X),
407# and pw (FreeBSD) used in enewuser()/enewgroup()
408# Joe Jezak <josejx@gmail.com> and usata@gentoo.org
409# FBSD stuff: Aaron Walker <ka0ttic@gentoo.org>
410#
411# egetent(database, key)
412egetent() {
413 case ${CHOST} in
414 *-darwin*)
415 case "$2" in
416 *[!0-9]*) # Non numeric
417 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }"
418 ;;
419 *) # Numeric
420 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
421 ;;
422 esac
423 ;;
424 *-freebsd*)
425 local opts action="user"
426 [[ $1 == "passwd" ]] || action="group"
427
428 # lookup by uid/gid
429 if [[ $2 == [[:digit:]]* ]] ; then
430 [[ ${action} == "user" ]] && opts="-u" || opts="-g"
431 fi
432
433 pw show ${action} ${opts} "$2" -q
434 ;;
435 *-netbsd*)
436 grep "$2:\*:" /etc/$1
437 ;;
438 *)
439 type -p nscd >& /dev/null && nscd -i "$1"
440 getent "$1" "$2"
441 ;;
442 esac
443}
444
445# Simplify/standardize adding users to the system
446# vapier@gentoo.org
447#
448# enewuser(username, uid, shell, homedir, groups, extra options)
449#
450# Default values if you do not specify any:
451# username: REQUIRED !
452# uid: next available (see useradd(8))
453# note: pass -1 to get default behavior
454# shell: /bin/false
455# homedir: /dev/null
456# groups: none
457# extra: comment of 'added by portage for ${PN}'
458enewuser() {
459 # get the username
460 local euser=$1; shift
461 if [[ -z ${euser} ]] ; then
462 eerror "No username specified !"
463 die "Cannot call enewuser without a username"
464 fi
465
466 # lets see if the username already exists
467 if [[ ${euser} == $(egetent passwd "${euser}" | cut -d: -f1) ]] ; then
468 return 0
469 fi
470 einfo "Adding user '${euser}' to your system ..."
471
472 # options to pass to useradd
473 local opts=
474
475 # handle uid
476 local euid=$1; shift
477 if [[ ! -z ${euid} ]] && [[ ${euid} != "-1" ]] ; then
478 if [[ ${euid} -gt 0 ]] ; then
479 if [[ ! -z $(egetent passwd ${euid}) ]] ; then
480 euid="next"
481 fi
482 else 655 else
483 eerror "Userid given but is not greater than 0 !" 656 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX
484 die "${euid} is not a valid UID"
485 fi
486 else
487 euid="next"
488 fi
489 if [[ ${euid} == "next" ]] ; then
490 for euid in $(seq 101 999) ; do
491 [[ -z $(egetent passwd ${euid}) ]] && break
492 done
493 fi
494 opts="${opts} -u ${euid}"
495 einfo " - Userid: ${euid}"
496
497 # handle shell
498 local eshell=$1; shift
499 if [[ ! -z ${eshell} ]] && [[ ${eshell} != "-1" ]] ; then
500 if [[ ! -e ${eshell} ]] ; then
501 eerror "A shell was specified but it does not exist !"
502 die "${eshell} does not exist"
503 fi
504 else
505 for shell in /sbin/nologin /usr/sbin/nologin /bin/false /usr/bin/false /dev/null ; do
506 [[ -x ${ROOT}${shell} ]] && break
507 done
508
509 if [[ ${shell} == "/dev/null" ]] ; then
510 eerror "Unable to identify the shell to use"
511 die "Unable to identify the shell to use"
512 fi
513
514 eshell=${shell}
515 fi
516 einfo " - Shell: ${eshell}"
517 opts="${opts} -s ${eshell}"
518
519 # handle homedir
520 local ehome=$1; shift
521 if [[ -z ${ehome} ]] || [[ ${ehome} == "-1" ]] ; then
522 ehome="/dev/null"
523 fi
524 einfo " - Home: ${ehome}"
525 opts="${opts} -d ${ehome}"
526
527 # handle groups
528 local egroups=$1; shift
529 if [[ ! -z ${egroups} ]] ; then
530 local oldifs=${IFS}
531 local defgroup="" exgroups=""
532
533 export IFS=","
534 for g in ${egroups} ; do
535 export IFS=${oldifs}
536 if [[ -z $(egetent group "${g}") ]] ; then
537 eerror "You must add group ${g} to the system first"
538 die "${g} is not a valid GID"
539 fi 657 fi
540 if [[ -z ${defgroup} ]] ; then
541 defgroup=${g}
542 else
543 exgroups="${exgroups},${g}"
544 fi
545 export IFS=","
546 done
547 export IFS=${oldifs}
548
549 opts="${opts} -g ${defgroup}"
550 if [[ ! -z ${exgroups} ]] ; then
551 opts="${opts} -G ${exgroups:1}"
552 fi 658 fi
553 else
554 egroups="(none)"
555 fi
556 einfo " - Groups: ${egroups}"
557
558 # handle extra and add the user
559 local oldsandbox=${SANDBOX_ON}
560 export SANDBOX_ON="0"
561 case ${CHOST} in
562 *-darwin*)
563 ### Make the user
564 if [[ -z $@ ]] ; then
565 dscl . create /users/${euser} uid ${euid}
566 dscl . create /users/${euser} shell ${eshell}
567 dscl . create /users/${euser} home ${ehome}
568 dscl . create /users/${euser} realname "added by portage for ${PN}"
569 ### Add the user to the groups specified
570 local oldifs=${IFS}
571 export IFS=","
572 for g in ${egroups} ; do
573 dscl . merge /groups/${g} users ${euser}
574 done
575 export IFS=${oldifs}
576 else
577 einfo "Extra options are not supported on Darwin yet"
578 einfo "Please report the ebuild along with the info below"
579 einfo "eextra: $@"
580 die "Required function missing"
581 fi
582 ;;
583 *-freebsd*)
584 if [[ -z $@ ]] ; then
585 pw useradd ${euser} ${opts} \
586 -c "added by portage for ${PN}" \
587 die "enewuser failed"
588 else
589 einfo " - Extra: $@"
590 pw useradd ${euser} ${opts} \
591 "$@" || die "enewuser failed"
592 fi
593 ;;
594 *)
595 if [[ -z $@ ]] ; then
596 useradd ${opts} ${euser} \
597 -c "added by portage for ${PN}" \
598 || die "enewuser failed"
599 else
600 einfo " - Extra: $@"
601 useradd ${opts} ${euser} "$@" \
602 || die "enewuser failed"
603 fi
604 ;;
605 esac
606
607 if [[ ! -e ${ROOT}/${ehome} ]] ; then
608 einfo " - Creating ${ehome} in ${ROOT}"
609 mkdir -p "${ROOT}/${ehome}"
610 chown ${euser} "${ROOT}/${ehome}"
611 chmod 755 "${ROOT}/${ehome}"
612 fi
613
614 export SANDBOX_ON=${oldsandbox}
615} 659}
616 660
617# Simplify/standardize adding groups to the system 661# @FUNCTION: edos2unix
618# vapier@gentoo.org 662# @USAGE: <file> [more files ...]
619# 663# @DESCRIPTION:
620# enewgroup(group, gid) 664# A handy replacement for dos2unix, recode, fixdos, etc... This allows you
621# 665# to remove all of these text utilities from DEPEND variables because this
622# Default values if you do not specify any: 666# is a script based solution. Just give it a list of files to convert and
623# groupname: REQUIRED ! 667# they will all be changed from the DOS CRLF format to the UNIX LF format.
624# gid: next available (see groupadd(8))
625# extra: none
626enewgroup() {
627 # get the group
628 local egroup="$1"; shift
629 if [ -z "${egroup}" ]
630 then
631 eerror "No group specified !"
632 die "Cannot call enewgroup without a group"
633 fi
634
635 # see if group already exists
636 if [ "${egroup}" == "`egetent group \"${egroup}\" | cut -d: -f1`" ]
637 then
638 return 0
639 fi
640 einfo "Adding group '${egroup}' to your system ..."
641
642 # options to pass to useradd
643 local opts=
644
645 # handle gid
646 local egid="$1"; shift
647 if [ ! -z "${egid}" ]
648 then
649 if [ "${egid}" -gt 0 ]
650 then
651 if [ -z "`egetent group ${egid}`" ]
652 then
653 if [[ "${CHOST}" == *-darwin* ]]; then
654 opts="${opts} ${egid}"
655 else
656 opts="${opts} -g ${egid}"
657 fi
658 else
659 egid="next available; requested gid taken"
660 fi
661 else
662 eerror "Groupid given but is not greater than 0 !"
663 die "${egid} is not a valid GID"
664 fi
665 else
666 egid="next available"
667 fi
668 einfo " - Groupid: ${egid}"
669
670 # handle extra
671 local eextra="$@"
672 opts="${opts} ${eextra}"
673
674 # add the group
675 local oldsandbox="${SANDBOX_ON}"
676 export SANDBOX_ON="0"
677 case ${CHOST} in
678 *-darwin*)
679 if [ ! -z "${eextra}" ];
680 then
681 einfo "Extra options are not supported on Darwin/OS X yet"
682 einfo "Please report the ebuild along with the info below"
683 einfo "eextra: ${eextra}"
684 die "Required function missing"
685 fi
686
687 # If we need the next available
688 case ${egid} in
689 *[!0-9]*) # Non numeric
690 for egid in $(seq 101 999); do
691 [ -z "`egetent group ${egid}`" ] && break
692 done
693 esac
694 dscl . create /groups/${egroup} gid ${egid}
695 dscl . create /groups/${egroup} passwd '*'
696 ;;
697
698 *-freebsd*)
699 case ${egid} in
700 *[!0-9]*) # Non numeric
701 for egid in $(seq 101 999); do
702 [ -z "`egetent group ${egid}`" ] && break
703 done
704 esac
705 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed"
706 ;;
707
708 *-netbsd*)
709 case ${egid} in
710 *[!0-9]*) # Non numeric
711 for egid in $(seq 101 999); do
712 [ -z "`egetent group ${egid}`" ] && break
713 done
714 esac
715 groupadd ${egroup} -g ${egid} || die "enewgroup failed"
716 ;;
717
718 *)
719 groupadd ${opts} ${egroup} || die "enewgroup failed"
720 ;;
721 esac
722 export SANDBOX_ON="${oldsandbox}"
723}
724
725# Simple script to replace 'dos2unix' binaries
726# vapier@gentoo.org
727#
728# edos2unix(file, <more files> ...)
729edos2unix() { 668edos2unix() {
730 for f in "$@" 669 [[ $# -eq 0 ]] && return 0
731 do 670 sed -i 's/\r$//' -- "$@" || die
732 cp "${f}" ${T}/edos2unix
733 sed 's/\r$//' ${T}/edos2unix > "${f}"
734 done
735} 671}
736 672
737 673# @FUNCTION: make_desktop_entry
738############################################################## 674# @USAGE: make_desktop_entry(<command>, [name], [icon], [type], [fields])
739# START: Handle .desktop files and menu entries # 675# @DESCRIPTION:
740# maybe this should be separated into a new eclass some time #
741# lanius@gentoo.org #
742##############################################################
743
744# Make a desktop file ! 676# Make a .desktop file.
745# Great for making those icons in kde/gnome startmenu !
746# Amaze your friends ! Get the women ! Join today !
747# 677#
748# make_desktop_entry(<binary>, [name], [icon], [type], [path]) 678# @CODE
749#
750# binary: what binary does the app run with ? 679# binary: what command does the app run with ?
751# name: the name that will show up in the menu 680# name: the name that will show up in the menu
752# icon: give your little like a pretty little icon ... 681# icon: the icon to use in the menu entry
753# this can be relative (to /usr/share/pixmaps) or 682# this can be relative (to /usr/share/pixmaps) or
754# a full path to an icon 683# a full path to an icon
755# type: what kind of application is this ? for categories: 684# type: what kind of application is this?
756# http://www.freedesktop.org/Standards/desktop-entry-spec 685# for categories:
757# path: if your app needs to startup in a specific dir 686# http://standards.freedesktop.org/menu-spec/latest/apa.html
687# if unset, function tries to guess from package's category
688# fields: extra fields to append to the desktop file; a printf string
689# @CODE
758make_desktop_entry() { 690make_desktop_entry() {
759 [[ -z $1 ]] && eerror "make_desktop_entry: You must specify the executable" && return 1 691 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
760 692
761 local exec=${1} 693 local exec=${1}
762 local name=${2:-${PN}} 694 local name=${2:-${PN}}
763 local icon=${3:-${PN}.png} 695 local icon=${3:-${PN}}
764 local type=${4} 696 local type=${4}
765 local path=${5} 697 local fields=${5}
766 698
767 if [[ -z ${type} ]] ; then 699 if [[ -z ${type} ]] ; then
768 local catmaj=${CATEGORY%%-*} 700 local catmaj=${CATEGORY%%-*}
769 local catmin=${CATEGORY##*-} 701 local catmin=${CATEGORY##*-}
770 case ${catmaj} in 702 case ${catmaj} in
771 app) 703 app)
772 case ${catmin} in 704 case ${catmin} in
705 accessibility) type="Utility;Accessibility";;
773 admin) type=System;; 706 admin) type=System;;
707 antivirus) type=System;;
708 arch) type="Utility;Archiving";;
709 backup) type="Utility;Archiving";;
774 cdr) type=DiscBurning;; 710 cdr) type="AudioVideo;DiscBurning";;
775 dicts) type=Dictionary;; 711 dicts) type="Office;Dictionary";;
712 doc) type=Documentation;;
776 editors) type=TextEditor;; 713 editors) type="Utility;TextEditor";;
777 emacs) type=TextEditor;; 714 emacs) type="Development;TextEditor";;
778 emulation) type=Emulator;; 715 emulation) type="System;Emulator";;
779 laptop) type=HardwareSettings;; 716 laptop) type="Settings;HardwareSettings";;
780 office) type=Office;; 717 office) type=Office;;
718 pda) type="Office;PDA";;
781 vim) type=TextEditor;; 719 vim) type="Development;TextEditor";;
782 xemacs) type=TextEditor;; 720 xemacs) type="Development;TextEditor";;
783 *) type=;;
784 esac 721 esac
785 ;; 722 ;;
786 723
787 dev) 724 dev)
788 type="Development" 725 type="Development"
789 ;; 726 ;;
790 727
791 games) 728 games)
792 case ${catmin} in 729 case ${catmin} in
793 action) type=ActionGame;; 730 action|fps) type=ActionGame;;
794 arcade) type=ArcadeGame;; 731 arcade) type=ArcadeGame;;
795 board) type=BoardGame;; 732 board) type=BoardGame;;
796 kid) type=KidsGame;;
797 emulation) type=Emulator;; 733 emulation) type=Emulator;;
734 kids) type=KidsGame;;
798 puzzle) type=LogicGame;; 735 puzzle) type=LogicGame;;
736 roguelike) type=RolePlaying;;
799 rpg) type=RolePlaying;; 737 rpg) type=RolePlaying;;
800 roguelike) type=RolePlaying;;
801 simulation) type=Simulation;; 738 simulation) type=Simulation;;
802 sports) type=SportsGame;; 739 sports) type=SportsGame;;
803 strategy) type=StrategyGame;; 740 strategy) type=StrategyGame;;
804 *) type=;;
805 esac 741 esac
806 type="Game;${type}" 742 type="Game;${type}"
807 ;; 743 ;;
808 744
745 gnome)
746 type="Gnome;GTK"
747 ;;
748
749 kde)
750 type="KDE;Qt"
751 ;;
752
809 mail) 753 mail)
810 type="Network;Email" 754 type="Network;Email"
811 ;; 755 ;;
812 756
813 media) 757 media)
814 case ${catmin} in 758 case ${catmin} in
759 gfx)
815 gfx) type=Graphics;; 760 type=Graphics
761 ;;
762 *)
763 case ${catmin} in
816 radio) type=Tuner;; 764 radio) type=Tuner;;
817 sound) type=Audio;; 765 sound) type=Audio;;
818 tv) type=TV;; 766 tv) type=TV;;
819 video) type=Video;; 767 video) type=Video;;
820 *) type=;; 768 esac
769 type="AudioVideo;${type}"
770 ;;
821 esac 771 esac
822 type="AudioVideo;${type}"
823 ;; 772 ;;
824 773
825 net) 774 net)
826 case ${catmin} in 775 case ${catmin} in
827 dialup) type=Dialup;; 776 dialup) type=Dialup;;
830 irc) type=IRCClient;; 779 irc) type=IRCClient;;
831 mail) type=Email;; 780 mail) type=Email;;
832 news) type=News;; 781 news) type=News;;
833 nntp) type=News;; 782 nntp) type=News;;
834 p2p) type=FileTransfer;; 783 p2p) type=FileTransfer;;
835 *) type=;; 784 voip) type=Telephony;;
836 esac 785 esac
837 type="Network;${type}" 786 type="Network;${type}"
838 ;; 787 ;;
839 788
840 sci) 789 sci)
841 case ${catmin} in 790 case ${catmin} in
842 astro*) type=Astronomoy;; 791 astro*) type=Astronomy;;
843 bio*) type=Biology;; 792 bio*) type=Biology;;
844 calc*) type=Calculator;; 793 calc*) type=Calculator;;
845 chem*) type=Chemistry;; 794 chem*) type=Chemistry;;
795 elec*) type=Electronics;;
846 geo*) type=Geology;; 796 geo*) type=Geology;;
847 math*) type=Math;; 797 math*) type=Math;;
848 *) type=;; 798 physics) type=Physics;;
799 visual*) type=DataVisualization;;
849 esac 800 esac
850 type="Science;${type}" 801 type="Education;Science;${type}"
802 ;;
803
804 sys)
805 type="System"
851 ;; 806 ;;
852 807
853 www) 808 www)
854 case ${catmin} in 809 case ${catmin} in
855 client) type=WebBrowser;; 810 client) type=WebBrowser;;
856 *) type=;;
857 esac 811 esac
858 type="Network" 812 type="Network;${type}"
859 ;; 813 ;;
860 814
861 *) 815 *)
862 type= 816 type=
863 ;; 817 ;;
866 if [ "${SLOT}" == "0" ] ; then 820 if [ "${SLOT}" == "0" ] ; then
867 local desktop_name="${PN}" 821 local desktop_name="${PN}"
868 else 822 else
869 local desktop_name="${PN}-${SLOT}" 823 local desktop_name="${PN}-${SLOT}"
870 fi 824 fi
825 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
871 local desktop=${T}/${exec%% *}-${desktop_name}.desktop 826 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
872 827
828 # Don't append another ";" when a valid category value is provided.
829 type=${type%;}${type:+;}
830
831 eshopts_push -s extglob
832 if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
833 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
834 ewarn "allowed in .desktop files if the value is not an absolute path."
835 icon=${icon%.@(xpm|png|svg)}
836 fi
837 eshopts_pop
838
839 cat <<-EOF > "${desktop}"
873echo "[Desktop Entry] 840 [Desktop Entry]
874Encoding=UTF-8
875Version=0.9.2
876Name=${name} 841 Name=${name}
877Type=Application 842 Type=Application
878Comment=${DESCRIPTION} 843 Comment=${DESCRIPTION}
879Exec=${exec} 844 Exec=${exec}
880Path=${path} 845 TryExec=${exec%% *}
881Icon=${icon} 846 Icon=${icon}
882Categories=Application;${type};" > "${desktop}" 847 Categories=${type}
848 EOF
849
850 if [[ ${fields:-=} != *=* ]] ; then
851 # 5th arg used to be value to Path=
852 ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
853 fields="Path=${fields}"
854 fi
855 [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
883 856
884 ( 857 (
885 # wrap the env here so that the 'insinto' call 858 # wrap the env here so that the 'insinto' call
886 # doesn't corrupt the env of the caller 859 # doesn't corrupt the env of the caller
887 insinto /usr/share/applications 860 insinto /usr/share/applications
888 doins "${desktop}" 861 doins "${desktop}"
889 ) 862 ) || die "installing desktop file failed"
890} 863}
891 864
892# Make a GDM/KDM Session file 865# @FUNCTION: validate_desktop_entries
893# 866# @USAGE: [directories]
894# make_desktop_entry(<title>, <command>) 867# @MAINTAINER:
895# title: File to execute to start the Window Manager 868# Carsten Lohrke <carlo@gentoo.org>
896# command: Name of the Window Manager 869# @DESCRIPTION:
870# Validate desktop entries using desktop-file-utils
871validate_desktop_entries() {
872 if [[ -x /usr/bin/desktop-file-validate ]] ; then
873 einfo "Checking desktop entry validity"
874 local directories=""
875 for d in /usr/share/applications $@ ; do
876 [[ -d ${D}${d} ]] && directories="${directories} ${D}${d}"
877 done
878 if [[ -n ${directories} ]] ; then
879 for FILE in $(find ${directories} -name "*\.desktop" \
880 -not -path '*.hidden*' | sort -u 2>/dev/null)
881 do
882 local temp=$(desktop-file-validate ${FILE} | grep -v "warning:" | \
883 sed -e "s|error: ||" -e "s|${FILE}:|--|g" )
884 [[ -n $temp ]] && elog ${temp/--/${FILE/${D}/}:}
885 done
886 fi
887 echo ""
888 else
889 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
890 fi
891}
897 892
893# @FUNCTION: make_session_desktop
894# @USAGE: <title> <command> [command args...]
895# @DESCRIPTION:
896# Make a GDM/KDM Session file. The title is the file to execute to start the
897# Window Manager. The command is the name of the Window Manager.
898#
899# You can set the name of the file via the ${wm} variable.
898make_session_desktop() { 900make_session_desktop() {
899 [[ -z $1 ]] && eerror "make_session_desktop: You must specify the title" && return 1 901 [[ -z $1 ]] && eerror "$0: You must specify the title" && return 1
900 [[ -z $2 ]] && eerror "make_session_desktop: You must specify the command" && return 1 902 [[ -z $2 ]] && eerror "$0: You must specify the command" && return 1
901 903
902 local title=$1 904 local title=$1
903 local command=$2 905 local command=$2
904 local desktop=${T}/${wm}.desktop 906 local desktop=${T}/${wm:-${PN}}.desktop
907 shift 2
905 908
909 cat <<-EOF > "${desktop}"
906echo "[Desktop Entry] 910 [Desktop Entry]
907Encoding=UTF-8
908Name=${title} 911 Name=${title}
909Comment=This session logs you into ${title} 912 Comment=This session logs you into ${title}
910Exec=${command} 913 Exec=${command} $*
911TryExec=${command} 914 TryExec=${command}
912Type=Application" > "${desktop}" 915 Type=XSession
916 EOF
913 917
918 (
919 # wrap the env here so that the 'insinto' call
920 # doesn't corrupt the env of the caller
914 insinto /usr/share/xsessions 921 insinto /usr/share/xsessions
915 doins "${desktop}" 922 doins "${desktop}"
923 )
916} 924}
917 925
926# @FUNCTION: domenu
927# @USAGE: <menus>
928# @DESCRIPTION:
929# Install the list of .desktop menu files into the appropriate directory
930# (/usr/share/applications).
918domenu() { 931domenu() {
932 (
933 # wrap the env here so that the 'insinto' call
934 # doesn't corrupt the env of the caller
919 local i j 935 local i j ret=0
920 insinto /usr/share/applications 936 insinto /usr/share/applications
921 for i in "$@" ; do 937 for i in "$@" ; do
922 if [[ -f ${i} ]] ; then 938 if [[ -f ${i} ]] ; then
923 doins "${i}" 939 doins "${i}"
940 ((ret+=$?))
924 elif [[ -d ${i} ]] ; then 941 elif [[ -d ${i} ]] ; then
925 for j in "${i}"/*.desktop ; do 942 for j in "${i}"/*.desktop ; do
926 doins "${j}" 943 doins "${j}"
944 ((ret+=$?))
927 done 945 done
946 else
947 ((++ret))
928 fi 948 fi
929 done 949 done
950 exit ${ret}
951 )
930} 952}
953
954# @FUNCTION: newmenu
955# @USAGE: <menu> <newname>
956# @DESCRIPTION:
957# Like all other new* functions, install the specified menu as newname.
931newmenu() { 958newmenu() {
959 (
960 # wrap the env here so that the 'insinto' call
961 # doesn't corrupt the env of the caller
932 insinto /usr/share/applications 962 insinto /usr/share/applications
933 newins "$1" "$2" 963 newins "$@"
964 )
934} 965}
935 966
936doicon() { 967# @FUNCTION: _iconins
937 local i j 968# @INTERNAL
938 insinto /usr/share/pixmaps 969# @DESCRIPTION:
939 for i in "$@" ; do 970# function for use in doicon and newicon
940 if [[ -f ${i} ]] ; then 971_iconins() {
941 doins "${i}" 972 (
942 elif [[ -d ${i} ]] ; then 973 # wrap the env here so that the 'insinto' call
943 for j in "${i}"/*.png ; do 974 # doesn't corrupt the env of the caller
944 doins "${j}" 975 local funcname=$1; shift
945 done 976 local size dir
946 fi 977 local context=apps
947 done 978 local theme=hicolor
948}
949newicon() {
950 insinto /usr/share/pixmaps
951 newins "$1" "$2"
952}
953 979
954############################################################## 980 while [[ $# -gt 0 ]] ; do
955# END: Handle .desktop files and menu entries # 981 case $1 in
956############################################################## 982 -s|--size)
957 983 if [[ ${2%%x*}x${2%%x*} == "$2" ]] ; then
958 984 size=${2%%x*}
959# for internal use only (unpack_pdv and unpack_makeself)
960find_unpackable_file() {
961 local src=$1
962 if [[ -z ${src} ]] ; then
963 src=${DISTDIR}/${A}
964 else
965 if [[ -e ${DISTDIR}/${src} ]] ; then
966 src=${DISTDIR}/${src}
967 elif [[ -e ${PWD}/${src} ]] ; then
968 src=${PWD}/${src}
969 elif [[ -e ${src} ]] ; then
970 src=${src}
971 fi
972 fi
973 [[ ! -e ${src} ]] && return 1
974 echo "${src}"
975}
976
977# Unpack those pesky pdv generated files ...
978# They're self-unpacking programs with the binary package stuffed in
979# the middle of the archive. Valve seems to use it a lot ... too bad
980# it seems to like to segfault a lot :(. So lets take it apart ourselves.
981#
982# Usage: unpack_pdv [file to unpack] [size of off_t]
983# - you have to specify the off_t size ... i have no idea how to extract that
984# information out of the binary executable myself. basically you pass in
985# the size of the off_t type (in bytes) on the machine that built the pdv
986# archive. one way to determine this is by running the following commands:
987# strings <pdv archive> | grep lseek
988# strace -elseek <pdv archive>
989# basically look for the first lseek command (we do the strings/grep because
990# sometimes the function call is _llseek or something) and steal the 2nd
991# parameter. here is an example:
992# root@vapier 0 pdv_unpack # strings hldsupdatetool.bin | grep lseek
993# lseek
994# root@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin
995# lseek(3, -4, SEEK_END) = 2981250
996# thus we would pass in the value of '4' as the second parameter.
997unpack_pdv() {
998 local src=$(find_unpackable_file $1)
999 local sizeoff_t=$2
1000
1001 [[ -z ${src} ]] && die "Could not locate source for '$1'"
1002 [[ -z ${sizeoff_t} ]] && die "No idea what off_t size was used for this pdv :("
1003
1004 local shrtsrc="`basename ${src}`"
1005 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1006 local metaskip=`tail -c ${sizeoff_t} ${src} | hexdump -e \"%i\"`
1007 local tailskip=`tail -c $((${sizeoff_t}*2)) ${src} | head -c ${sizeoff_t} | hexdump -e \"%i\"`
1008
1009 # grab metadata for debug reasons
1010 local metafile="$(emktemp)"
1011 tail -c +$((${metaskip}+1)) ${src} > ${metafile}
1012
1013 # rip out the final file name from the metadata
1014 local datafile="`tail -c +$((${metaskip}+1)) ${src} | strings | head -n 1`"
1015 datafile="`basename ${datafile}`"
1016
1017 # now lets uncompress/untar the file if need be
1018 local tmpfile="$(emktemp)"
1019 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null | head -c 512 > ${tmpfile}
1020
1021 local iscompressed="`file -b ${tmpfile}`"
1022 if [ "${iscompressed:0:8}" == "compress" ] ; then
1023 iscompressed=1
1024 mv ${tmpfile}{,.Z}
1025 gunzip ${tmpfile}
1026 else
1027 iscompressed=0
1028 fi
1029 local istar="`file -b ${tmpfile}`"
1030 if [ "${istar:0:9}" == "POSIX tar" ] ; then
1031 istar=1
1032 else
1033 istar=0
1034 fi
1035
1036 #for some reason gzip dies with this ... dd cant provide buffer fast enough ?
1037 #dd if=${src} ibs=${metaskip} count=1 \
1038 # | dd ibs=${tailskip} skip=1 \
1039 # | gzip -dc \
1040 # > ${datafile}
1041 if [ ${iscompressed} -eq 1 ] ; then
1042 if [ ${istar} -eq 1 ] ; then
1043 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1044 | head -c $((${metaskip}-${tailskip})) \
1045 | tar -xzf -
1046 else 985 else
1047 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \ 986 size=${2}
1048 | head -c $((${metaskip}-${tailskip})) \
1049 | gzip -dc \
1050 > ${datafile}
1051 fi 987 fi
1052 else
1053 if [ ${istar} -eq 1 ] ; then
1054 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1055 | head -c $((${metaskip}-${tailskip})) \
1056 | tar --no-same-owner -xf -
1057 else
1058 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1059 | head -c $((${metaskip}-${tailskip})) \
1060 > ${datafile}
1061 fi
1062 fi
1063 true
1064 #[ -s "${datafile}" ] || die "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1065 #assert "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1066}
1067
1068# Unpack those pesky makeself generated files ...
1069# They're shell scripts with the binary package tagged onto
1070# the end of the archive. Loki utilized the format as does
1071# many other game companies.
1072#
1073# Usage: unpack_makeself [file to unpack] [offset] [tail|dd]
1074# - If the file is not specified then unpack will utilize ${A}.
1075# - If the offset is not specified then we will attempt to extract
1076# the proper offset from the script itself.
1077unpack_makeself() {
1078 local src=$(find_unpackable_file "$1")
1079 local skip=$2
1080 local exe=$3
1081
1082 [[ -z ${src} ]] && die "Could not locate source for '$1'"
1083
1084 local shrtsrc=$(basename "${src}")
1085 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1086 if [ -z "${skip}" ]
1087 then
1088 local ver="`grep -a '#.*Makeself' ${src} | awk '{print $NF}'`"
1089 local skip=0
1090 exe=tail
1091 case ${ver} in 988 case ${size} in
1092 1.5.*) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same 989 16|22|24|32|36|48|64|72|96|128|192|256)
1093 skip=$(grep -a ^skip= "${src}" | cut -d= -f2) 990 size=${size}x${size};;
1094 ;; 991 scalable)
1095 2.0|2.0.1)
1096 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-)
1097 ;;
1098 2.1.1)
1099 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-)
1100 let skip="skip + 1"
1101 ;;
1102 2.1.2)
1103 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1)
1104 let skip="skip + 1"
1105 ;;
1106 2.1.3)
1107 skip=`grep -a ^offset= "${src}" | awk '{print $3}'`
1108 let skip="skip + 1"
1109 ;;
1110 2.1.4)
1111 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1)
1112 skip=$(head -n ${skip} "${src}" | wc -c)
1113 exe="dd"
1114 ;; 992 ;;
1115 *) 993 *)
1116 eerror "I'm sorry, but I was unable to support the Makeself file." 994 eerror "${size} is an unsupported icon size!"
1117 eerror "The version I detected was '${ver}'." 995 exit 1;;
1118 eerror "Please file a bug about the file ${shrtsrc} at" 996 esac
1119 eerror "http://bugs.gentoo.org/ so that support can be added." 997 shift 2;;
1120 die "makeself version '${ver}' not supported" 998 -t|--theme)
1121 ;; 999 theme=${2}
1000 shift 2;;
1001 -c|--context)
1002 context=${2}
1003 shift 2;;
1004 *)
1005 if [[ -z ${size} ]] ; then
1006 insinto /usr/share/pixmaps
1007 else
1008 insinto /usr/share/icons/${theme}/${size}/${context}
1009 fi
1010
1011 if [[ ${funcname} == doicon ]] ; then
1012 if [[ -f $1 ]] ; then
1013 doins "${1}"
1014 elif [[ -d $1 ]] ; then
1015 shopt -s nullglob
1016 doins "${1}"/*.{png,svg}
1017 shopt -u nullglob
1018 else
1019 eerror "${1} is not a valid file/directory!"
1020 exit 1
1021 fi
1022 else
1023 break
1024 fi
1025 shift 1;;
1122 esac 1026 esac
1123 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset"
1124 fi
1125 case ${exe} in
1126 tail) exe="tail -n +${skip} '${src}'";;
1127 dd) exe="dd ibs=${skip} skip=1 obs=1024 conv=sync if='${src}'";;
1128 *) die "makeself cant handle exe '${exe}'"
1129 esac
1130
1131 # lets grab the first few bytes of the file to figure out what kind of archive it is
1132 local tmpfile="$(emktemp)"
1133 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}"
1134 local filetype="$(file -b "${tmpfile}")"
1135 case ${filetype} in
1136 *tar\ archive)
1137 eval ${exe} | tar --no-same-owner -xf -
1138 ;;
1139 bzip2*)
1140 eval ${exe} | bzip2 -dc | tar --no-same-owner -xf -
1141 ;;
1142 gzip*)
1143 eval ${exe} | tar --no-same-owner -xzf -
1144 ;;
1145 compress*)
1146 eval ${exe} | gunzip | tar --no-same-owner -xf -
1147 ;;
1148 *)
1149 eerror "Unknown filetype \"${filetype}\" ?"
1150 false
1151 ;;
1152 esac
1153 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})"
1154}
1155
1156# Display a license for user to accept.
1157#
1158# Usage: check_license [license]
1159# - If the file is not specified then ${LICENSE} is used.
1160check_license() {
1161 local lic=$1
1162 if [ -z "${lic}" ] ; then
1163 lic="${PORTDIR}/licenses/${LICENSE}"
1164 else
1165 if [ -e "${PORTDIR}/licenses/${lic}" ] ; then
1166 lic="${PORTDIR}/licenses/${lic}"
1167 elif [ -e "${PWD}/${lic}" ] ; then
1168 lic="${PWD}/${lic}"
1169 elif [ -e "${lic}" ] ; then
1170 lic="${lic}"
1171 fi
1172 fi
1173 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1174 local l="`basename ${lic}`"
1175
1176 # here is where we check for the licenses the user already
1177 # accepted ... if we don't find a match, we make the user accept
1178 local shopts=$-
1179 local alic
1180 set -o noglob #so that bash doesn't expand "*"
1181 for alic in ${ACCEPT_LICENSE} ; do
1182 if [[ ${alic} == * || ${alic} == ${l} ]]; then
1183 set +o noglob; set -${shopts} #reset old shell opts
1184 return 0
1185 fi
1186 done 1027 done
1187 set +o noglob; set -$shopts #reset old shell opts 1028 if [[ ${funcname} == newicon ]] ; then
1188 1029 newins "$@"
1189 local licmsg="$(emktemp)"
1190 cat << EOF > ${licmsg}
1191**********************************************************
1192The following license outlines the terms of use of this
1193package. You MUST accept this license for installation to
1194continue. When you are done viewing, hit 'q'. If you
1195CTRL+C out of this, the install will not run!
1196**********************************************************
1197
1198EOF
1199 cat ${lic} >> ${licmsg}
1200 ${PAGER:-less} ${licmsg} || die "Could not execute pager (${PAGER}) to accept ${lic}"
1201 einfon "Do you accept the terms of this license (${l})? [yes/no] "
1202 read alic
1203 case ${alic} in
1204 yes|Yes|y|Y)
1205 return 0
1206 ;;
1207 *)
1208 echo;echo;echo
1209 eerror "You MUST accept the license to continue! Exiting!"
1210 die "Failed to accept license"
1211 ;;
1212 esac
1213}
1214
1215# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates
1216# the whole 'non-interactive' policy, but damnit I want CD support !
1217#
1218# with these cdrom functions we handle all the user interaction and
1219# standardize everything. all you have to do is call cdrom_get_cds()
1220# and when the function returns, you can assume that the cd has been
1221# found at CDROM_ROOT.
1222#
1223# normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2',
1224# etc... if you want to give the cds better names, then just export
1225# the CDROM_NAME_X variables before calling cdrom_get_cds().
1226#
1227# for those multi cd ebuilds, see the cdrom_load_next_cd() below.
1228#
1229# Usage: cdrom_get_cds <file on cd1> [file on cd2] [file on cd3] [...]
1230# - this will attempt to locate a cd based upon a file that is on
1231# the cd ... the more files you give this function, the more cds
1232# the cdrom functions will handle
1233cdrom_get_cds() {
1234 # first we figure out how many cds we're dealing with by
1235 # the # of files they gave us
1236 local cdcnt=0
1237 local f=
1238 for f in "$@" ; do
1239 cdcnt=$((cdcnt + 1))
1240 export CDROM_CHECK_${cdcnt}="$f"
1241 done
1242 export CDROM_TOTAL_CDS=${cdcnt}
1243 export CDROM_CURRENT_CD=1
1244
1245 # now we see if the user gave use CD_ROOT ...
1246 # if they did, let's just believe them that it's correct
1247 if [[ ! -z ${CD_ROOT} ]] ; then
1248 export CDROM_ROOT=${CD_ROOT}
1249 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1250 return
1251 fi
1252 # do the same for CD_ROOT_X
1253 if [[ ! -z ${CD_ROOT_1} ]] ; then
1254 local var=
1255 cdcnt=0
1256 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1257 cdcnt=$((cdcnt + 1))
1258 var="CD_ROOT_${cdcnt}"
1259 if [[ -z ${!var} ]] ; then
1260 eerror "You must either use just the CD_ROOT"
1261 eerror "or specify ALL the CD_ROOT_X variables."
1262 eerror "In this case, you will need ${CDROM_TOTAL_CDS} CD_ROOT_X variables."
1263 die "could not locate CD_ROOT_${cdcnt}"
1264 fi
1265 export CDROM_ROOTS_${cdcnt}="${!var}"
1266 done
1267 export CDROM_ROOT=${CDROM_ROOTS_1}
1268 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1269 return
1270 fi
1271
1272 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1273 einfon "This ebuild will need the "
1274 if [[ -z ${CDROM_NAME} ]] ; then
1275 echo "cdrom for ${PN}."
1276 else
1277 echo "${CDROM_NAME}."
1278 fi 1030 fi
1279 echo 1031 ) || die
1280 einfo "If you do not have the CD, but have the data files"
1281 einfo "mounted somewhere on your filesystem, just export"
1282 einfo "the variable CD_ROOT so that it points to the"
1283 einfo "directory containing the files."
1284 echo
1285 einfo "For example:"
1286 einfo "export CD_ROOT=/mnt/cdrom"
1287 echo
1288 else
1289 einfo "This package will need access to ${CDROM_TOTAL_CDS} cds."
1290 cdcnt=0
1291 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1292 cdcnt=$((cdcnt + 1))
1293 var="CDROM_NAME_${cdcnt}"
1294 [[ ! -z ${!var} ]] && einfo " CD ${cdcnt}: ${!var}"
1295 done
1296 echo
1297 einfo "If you do not have the CDs, but have the data files"
1298 einfo "mounted somewhere on your filesystem, just export"
1299 einfo "the following variables so they point to the right place:"
1300 einfon ""
1301 cdcnt=0
1302 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1303 cdcnt=$((cdcnt + 1))
1304 echo -n " CD_ROOT_${cdcnt}"
1305 done
1306 echo
1307 einfo "Or, if you have all the files in the same place, or"
1308 einfo "you only have one cdrom, you can export CD_ROOT"
1309 einfo "and that place will be used as the same data source"
1310 einfo "for all the CDs."
1311 echo
1312 einfo "For example:"
1313 einfo "export CD_ROOT_1=/mnt/cdrom"
1314 echo
1315 fi
1316 export CDROM_CURRENT_CD=0
1317 cdrom_load_next_cd
1318} 1032}
1319 1033
1320# this is only used when you need access to more than one cd. 1034# @FUNCTION: doicon
1321# when you have finished using the first cd, just call this function. 1035# @USAGE: [options] <icons>
1322# when it returns, CDROM_ROOT will be pointing to the second cd. 1036# @DESCRIPTION:
1323# remember, you can only go forward in the cd chain, you can't go back. 1037# Install icon into the icon directory /usr/share/icons or into
1324cdrom_load_next_cd() { 1038# /usr/share/pixmaps if "--size" is not set.
1325 export CDROM_CURRENT_CD=$((CDROM_CURRENT_CD + 1)) 1039# This is useful in conjunction with creating desktop/menu files.
1326 local var= 1040#
1327 1041# @CODE
1328 if [[ ! -z ${CD_ROOT} ]] ; then 1042# options:
1329 einfo "Using same root as before for CD #${CDROM_CURRENT_CD}" 1043# -s, --size
1330 return 1044# !!! must specify to install into /usr/share/icons/... !!!
1331 fi 1045# size of the icon, like 48 or 48x48
1332 1046# supported icon sizes are:
1333 unset CDROM_ROOT 1047# 16 22 24 32 36 48 64 72 96 128 192 256 scalable
1334 var=CDROM_ROOTS_${CDROM_CURRENT_CD} 1048# -c, --context
1335 if [[ -z ${!var} ]] ; then 1049# defaults to "apps"
1336 var="CDROM_CHECK_${CDROM_CURRENT_CD}" 1050# -t, --theme
1337 cdrom_locate_file_on_cd ${!var} 1051# defaults to "hicolor"
1338 else 1052#
1339 export CDROM_ROOT=${!var} 1053# icons: list of icons
1340 fi 1054#
1341 1055# example 1: doicon foobar.png fuqbar.svg suckbar.png
1342 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}" 1056# results in: insinto /usr/share/pixmaps
1057# doins foobar.png fuqbar.svg suckbar.png
1058#
1059# example 2: doicon -s 48 foobar.png fuqbar.png blobbar.png
1060# results in: insinto /usr/share/icons/hicolor/48x48/apps
1061# doins foobar.png fuqbar.png blobbar.png
1062# @CODE
1063doicon() {
1064 _iconins ${FUNCNAME} "$@"
1343} 1065}
1344 1066
1345# this is used internally by the cdrom_get_cds() and cdrom_load_next_cd() 1067# @FUNCTION: newicon
1346# functions. this should *never* be called from an ebuild. 1068# @USAGE: [options] <icon> <newname>
1347# all it does is try to locate a give file on a cd ... if the cd isn't 1069# @DESCRIPTION:
1348# found, then a message asking for the user to insert the cdrom will be 1070# Like doicon, install the specified icon as newname.
1349# displayed and we'll hang out here until: 1071#
1350# (1) the file is found on a mounted cdrom 1072# @CODE
1351# (2) the user hits CTRL+C 1073# example 1: newicon foobar.png NEWNAME.png
1352cdrom_locate_file_on_cd() { 1074# results in: insinto /usr/share/pixmaps
1353 while [[ -z ${CDROM_ROOT} ]] ; do 1075# newins foobar.png NEWNAME.png
1354 local dir=$(dirname "$*") 1076#
1355 local file=$(basename "$*") 1077# example 2: newicon -s 48 foobar.png NEWNAME.png
1356 local mline="" 1078# results in: insinto /usr/share/icons/hicolor/48x48/apps
1357 local showedmsg=0 1079# newins foobar.png NEWNAME.png
1358 1080# @CODE
1359 for mline in $(mount | egrep -e '(iso|cdrom)' | awk '{print $3}') ; do 1081newicon() {
1360 [[ -d ${mline}/${dir} ]] || continue 1082 _iconins ${FUNCNAME} "$@"
1361 [[ ! -z $(find ${mline}/${dir} -maxdepth 1 -iname ${file}) ]] \
1362 && export CDROM_ROOT=${mline}
1363 done
1364
1365 if [[ -z ${CDROM_ROOT} ]] ; then
1366 echo
1367 if [[ ${showedmsg} -eq 0 ]] ; then
1368 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1369 if [[ -z ${CDROM_NAME} ]] ; then
1370 einfo "Please insert the cdrom for ${PN} now !"
1371 else
1372 einfo "Please insert the ${CDROM_NAME} cdrom now !"
1373 fi
1374 else
1375 if [[ -z ${CDROM_NAME_1} ]] ; then
1376 einfo "Please insert cd #${CDROM_CURRENT_CD} for ${PN} now !"
1377 else
1378 local var="CDROM_NAME_${CDROM_CURRENT_CD}"
1379 einfo "Please insert+mount the ${!var} cdrom now !"
1380 fi
1381 fi
1382 showedmsg=1
1383 fi
1384 einfo "Press return to scan for the cd again"
1385 einfo "or hit CTRL+C to abort the emerge."
1386 echo
1387 einfo "If you are having trouble with the detection"
1388 einfo "of your CD, it is possible that you do not have"
1389 einfo "Joliet support enabled in your kernel. Please"
1390 einfo "check that CONFIG_JOLIET is enabled in your kernel."
1391 read
1392 fi
1393 done
1394} 1083}
1395 1084
1085# @FUNCTION: strip-linguas
1086# @USAGE: [<allow LINGUAS>|<-i|-u> <directories of .po files>]
1087# @DESCRIPTION:
1396# Make sure that LINGUAS only contains languages that 1088# Make sure that LINGUAS only contains languages that
1397# a package can support 1089# a package can support. The first form allows you to
1398# 1090# specify a list of LINGUAS. The -i builds a list of po
1399# usage: strip-linguas <allow LINGUAS> 1091# files found in all the directories and uses the
1400# strip-linguas -i <directories of .po files> 1092# intersection of the lists. The -u builds a list of po
1401# strip-linguas -u <directories of .po files> 1093# files found in all the directories and uses the union
1402# 1094# of the lists.
1403# The first form allows you to specify a list of LINGUAS.
1404# The -i builds a list of po files found in all the
1405# directories and uses the intersection of the lists.
1406# The -u builds a list of po files found in all the
1407# directories and uses the union of the lists.
1408strip-linguas() { 1095strip-linguas() {
1409 local ls newls 1096 local ls newls nols
1410 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then 1097 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1411 local op=$1; shift 1098 local op=$1; shift
1412 ls=" $(find "$1" -name '*.po' -printf '%f ') "; shift 1099 ls=$(find "$1" -name '*.po' -exec basename {} .po ';'); shift
1413 local d f 1100 local d f
1414 for d in "$@" ; do 1101 for d in "$@" ; do
1415 if [[ ${op} == "-u" ]] ; then 1102 if [[ ${op} == "-u" ]] ; then
1416 newls=${ls} 1103 newls=${ls}
1417 else 1104 else
1418 newls="" 1105 newls=""
1419 fi 1106 fi
1420 for f in $(find "$d" -name '*.po' -printf '%f ') ; do 1107 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1421 if [[ ${op} == "-i" ]] ; then 1108 if [[ ${op} == "-i" ]] ; then
1422 [[ ${ls/ ${f} /} != ${ls} ]] && newls="${newls} ${f}" 1109 has ${f} ${ls} && newls="${newls} ${f}"
1423 else 1110 else
1424 [[ ${ls/ ${f} /} == ${ls} ]] && newls="${newls} ${f}" 1111 has ${f} ${ls} || newls="${newls} ${f}"
1425 fi 1112 fi
1426 done 1113 done
1427 ls=${newls} 1114 ls=${newls}
1428 done 1115 done
1429 ls=${ls//.po}
1430 else 1116 else
1431 ls=$@ 1117 ls="$@"
1432 fi 1118 fi
1433 1119
1434 ls=" ${ls} " 1120 nols=""
1435 newls="" 1121 newls=""
1436 for f in ${LINGUAS} ; do 1122 for f in ${LINGUAS} ; do
1437 if [[ ${ls/ ${f} /} != ${ls} ]] ; then 1123 if has ${f} ${ls} ; then
1438 newls="${newls} ${f}" 1124 newls="${newls} ${f}"
1439 else 1125 else
1440 ewarn "Sorry, but ${PN} does not support the ${f} LINGUA" 1126 nols="${nols} ${f}"
1441 fi 1127 fi
1442 done 1128 done
1443 if [[ -z ${newls} ]] ; then 1129 [[ -n ${nols} ]] \
1444 export LINGUAS="" 1130 && einfo "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
1445 else
1446 export LINGUAS=${newls:1} 1131 export LINGUAS=${newls:1}
1447 fi
1448} 1132}
1449 1133
1450# moved from kernel.eclass since they are generally useful outside of 1134# @FUNCTION: preserve_old_lib
1451# kernel.eclass -iggy (20041002) 1135# @USAGE: <libs to preserve> [more libs]
1452 1136# @DESCRIPTION:
1453# the following functions are useful in kernel module ebuilds, etc.
1454# for an example see ivtv or drbd ebuilds
1455
1456# set's ARCH to match what the kernel expects
1457set_arch_to_kernel() {
1458 i=10
1459 while ((i--)) ; do
1460 ewarn "PLEASE UPDATE TO YOUR PACKAGE TO USE linux-info.eclass"
1461 done
1462 export EUTILS_ECLASS_PORTAGE_ARCH="${ARCH}"
1463 case ${ARCH} in
1464 x86) export ARCH="i386";;
1465 amd64) export ARCH="x86_64";;
1466 hppa) export ARCH="parisc";;
1467 mips) export ARCH="mips";;
1468 sparc) export ARCH="$(tc-arch-kernel)";; # Yeah this is ugly, but it's even WORSE if you don't do this. linux-info.eclass's set_arch_to_kernel is fixed, but won't get used over this one!
1469 *) export ARCH="${ARCH}";;
1470 esac
1471}
1472
1473# set's ARCH back to what portage expects
1474set_arch_to_portage() {
1475 i=10
1476 while ((i--)) ; do
1477 ewarn "PLEASE UPDATE TO YOUR PACKAGE TO USE linux-info.eclass"
1478 done
1479 export ARCH="${EUTILS_ECLASS_PORTAGE_ARCH}"
1480}
1481
1482# Jeremy Huddleston <eradicator@gentoo.org>:
1483# preserve_old_lib /path/to/libblah.so.0
1484# preserve_old_lib_notify /path/to/libblah.so.0
1485#
1486# These functions are useful when a lib in your package changes --soname. Such 1137# These functions are useful when a lib in your package changes ABI SONAME.
1487# an example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0 1138# An example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0
1488# would break packages that link against it. Most people get around this 1139# would break packages that link against it. Most people get around this
1489# by using the portage SLOT mechanism, but that is not always a relevant 1140# by using the portage SLOT mechanism, but that is not always a relevant
1490# solution, so instead you can add the following to your ebuilds: 1141# solution, so instead you can call this from pkg_preinst. See also the
1491# 1142# preserve_old_lib_notify function.
1492# src_install() {
1493# ...
1494# preserve_old_lib /usr/$(get_libdir)/libogg.so.0
1495# ...
1496# }
1497#
1498# pkg_postinst() {
1499# ...
1500# preserve_old_lib_notify /usr/$(get_libdir)/libogg.so.0
1501# ...
1502# }
1503
1504preserve_old_lib() { 1143preserve_old_lib() {
1505 LIB=$1 1144 if [[ ${EBUILD_PHASE} != "preinst" ]] ; then
1145 eerror "preserve_old_lib() must be called from pkg_preinst() only"
1146 die "Invalid preserve_old_lib() usage"
1147 fi
1148 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]"
1506 1149
1507 if [ -n "${LIB}" -a -f "${ROOT}${LIB}" ]; then 1150 # let portage worry about it
1508 SONAME=`basename ${LIB}` 1151 has preserve-libs ${FEATURES} && return 0
1509 DIRNAME=`dirname ${LIB}`
1510 1152
1511 dodir ${DIRNAME} 1153 local lib dir
1512 cp ${ROOT}${LIB} ${D}${DIRNAME} 1154 for lib in "$@" ; do
1155 [[ -e ${ROOT}/${lib} ]] || continue
1156 dir=${lib%/*}
1157 dodir ${dir} || die "dodir ${dir} failed"
1158 cp "${ROOT}"/${lib} "${D}"/${lib} || die "cp ${lib} failed"
1513 touch ${D}${LIB} 1159 touch "${D}"/${lib}
1514 fi 1160 done
1515} 1161}
1516 1162
1163# @FUNCTION: preserve_old_lib_notify
1164# @USAGE: <libs to notify> [more libs]
1165# @DESCRIPTION:
1166# Spit helpful messages about the libraries preserved by preserve_old_lib.
1517preserve_old_lib_notify() { 1167preserve_old_lib_notify() {
1518 LIB=$1 1168 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then
1169 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only"
1170 die "Invalid preserve_old_lib_notify() usage"
1171 fi
1519 1172
1520 if [ -n "${LIB}" -a -f "${ROOT}${LIB}" ]; then 1173 # let portage worry about it
1521 SONAME=`basename ${LIB}` 1174 has preserve-libs ${FEATURES} && return 0
1522 1175
1176 local lib notice=0
1177 for lib in "$@" ; do
1178 [[ -e ${ROOT}/${lib} ]] || continue
1179 if [[ ${notice} -eq 0 ]] ; then
1180 notice=1
1523 ewarn "An old version of an installed library was detected on your system." 1181 ewarn "Old versions of installed libraries were detected on your system."
1524 ewarn "In order to avoid breaking packages that link against it, this older version" 1182 ewarn "In order to avoid breaking packages that depend on these old libs,"
1525 ewarn "is not being removed. In order to make full use of this newer version," 1183 ewarn "the libraries are not being removed. You need to run revdep-rebuild"
1526 ewarn "you will need to execute the following command:" 1184 ewarn "in order to remove these old dependencies. If you do not have this"
1527 ewarn " revdep-rebuild --soname ${SONAME}" 1185 ewarn "helper program, simply emerge the 'gentoolkit' package."
1528 ewarn 1186 ewarn
1529 ewarn "After doing that, you can safely remove ${LIB}"
1530 ewarn "Note: 'emerge gentoolkit' to get revdep-rebuild"
1531 fi 1187 fi
1188 ewarn " # revdep-rebuild --library '${lib}' && rm '${lib}'"
1189 done
1532} 1190}
1533 1191
1534# Hack for people to figure out if a package was built with 1192# @FUNCTION: built_with_use
1535# certain USE flags 1193# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1194# @DESCRIPTION:
1536# 1195#
1537# Usage: built_with_use [-a|-o] <DEPEND ATOM> <List of USE flags> 1196# Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
1538# ex: built_with_use xchat gtk2
1539# 1197#
1540# Flags: -a all USE flags should be utilized 1198# A temporary hack until portage properly supports DEPENDing on USE
1541# -o at least one USE flag should be utilized 1199# flags being enabled in packages. This will check to see if the specified
1542# Note: the default flag is '-a' 1200# DEPEND atom was built with the specified list of USE flags. The
1201# --missing option controls the behavior if called on a package that does
1202# not actually support the defined USE flags (aka listed in IUSE).
1203# The default is to abort (call die). The -a and -o flags control
1204# the requirements of the USE flags. They correspond to "and" and "or"
1205# logic. So the -a flag means all listed USE flags must be enabled
1206# while the -o flag means at least one of the listed IUSE flags must be
1207# enabled. The --hidden option is really for internal use only as it
1208# means the USE flag we're checking is hidden expanded, so it won't be found
1209# in IUSE like normal USE flags.
1210#
1211# Remember that this function isn't terribly intelligent so order of optional
1212# flags matter.
1543built_with_use() { 1213built_with_use() {
1214 local hidden="no"
1215 if [[ $1 == "--hidden" ]] ; then
1216 hidden="yes"
1217 shift
1218 fi
1219
1220 local missing_action="die"
1221 if [[ $1 == "--missing" ]] ; then
1222 missing_action=$2
1223 shift ; shift
1224 case ${missing_action} in
1225 true|false|die) ;;
1226 *) die "unknown action '${missing_action}'";;
1227 esac
1228 fi
1229
1544 local opt=$1 1230 local opt=$1
1545 [[ ${opt:0:1} = "-" ]] && shift || opt="-a" 1231 [[ ${opt:0:1} = "-" ]] && shift || opt="-a"
1546 1232
1547 local PKG=$(best_version $1) 1233 local PKG=$(best_version $1)
1234 [[ -z ${PKG} ]] && die "Unable to resolve $1 to an installed package"
1548 shift 1235 shift
1549 1236
1550 local USEFILE="${ROOT}/var/db/pkg/${PKG}/USE" 1237 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE
1551 [[ ! -e ${USEFILE} ]] && return 1 1238 local IUSEFILE=${ROOT}/var/db/pkg/${PKG}/IUSE
1239
1240 # if the IUSE file doesn't exist, the read will error out, we need to handle
1241 # this gracefully
1242 if [[ ! -e ${USEFILE} ]] || [[ ! -e ${IUSEFILE} && ${hidden} == "no" ]] ; then
1243 case ${missing_action} in
1244 true) return 0;;
1245 false) return 1;;
1246 die) die "Unable to determine what USE flags $PKG was built with";;
1247 esac
1248 fi
1249
1250 if [[ ${hidden} == "no" ]] ; then
1251 local IUSE_BUILT=( $(<"${IUSEFILE}") )
1252 # Don't check USE_EXPAND #147237
1253 local expand
1254 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do
1255 if [[ $1 == ${expand}_* ]] ; then
1256 expand=""
1257 break
1258 fi
1259 done
1260 if [[ -n ${expand} ]] ; then
1261 if ! has $1 ${IUSE_BUILT[@]#[-+]} ; then
1262 case ${missing_action} in
1263 true) return 0;;
1264 false) return 1;;
1265 die) die "$PKG does not actually support the $1 USE flag!";;
1266 esac
1267 fi
1268 fi
1269 fi
1552 1270
1553 local USE_BUILT=$(<${USEFILE}) 1271 local USE_BUILT=$(<${USEFILE})
1554 while [[ $# -gt 0 ]] ; do 1272 while [[ $# -gt 0 ]] ; do
1555 if [[ ${opt} = "-o" ]] ; then 1273 if [[ ${opt} = "-o" ]] ; then
1556 has $1 ${USE_BUILT} && return 0 1274 has $1 ${USE_BUILT} && return 0
1560 shift 1278 shift
1561 done 1279 done
1562 [[ ${opt} = "-a" ]] 1280 [[ ${opt} = "-a" ]]
1563} 1281}
1564 1282
1283# @FUNCTION: epunt_cxx
1284# @USAGE: [dir to scan]
1285# @DESCRIPTION:
1565# Many configure scripts wrongly bail when a C++ compiler 1286# Many configure scripts wrongly bail when a C++ compiler could not be
1566# could not be detected. #73450 1287# detected. If dir is not specified, then it defaults to ${S}.
1288#
1289# http://bugs.gentoo.org/73450
1567epunt_cxx() { 1290epunt_cxx() {
1568 local dir=$1 1291 local dir=$1
1569 [[ -z ${dir} ]] && dir=${S} 1292 [[ -z ${dir} ]] && dir=${S}
1570 ebegin "Removing useless C++ checks" 1293 ebegin "Removing useless C++ checks"
1571 local f 1294 local f p any_found
1572 for f in $(find ${dir} -name configure) ; do 1295 while IFS= read -r -d '' f; do
1573 patch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null 1296 for p in "${PORTDIR}"/eclass/ELT-patches/nocxx/*.patch ; do
1297 if patch --no-backup-if-mismatch -p1 "${f}" "${p}" >/dev/null ; then
1298 any_found=1
1299 break
1300 fi
1574 done 1301 done
1302 done < <(find "${dir}" -name configure -print0)
1303
1304 if [[ -z ${any_found} ]]; then
1305 eqawarn "epunt_cxx called unnecessarily (no C++ checks to punt)."
1306 fi
1575 eend 0 1307 eend 0
1576} 1308}
1577 1309
1578# dopamd <file> [more files] 1310# @FUNCTION: make_wrapper
1579# 1311# @USAGE: <wrapper> <target> [chdir] [libpaths] [installpath]
1580# Install pam auth config file in /etc/pam.d 1312# @DESCRIPTION:
1581dopamd() { 1313# Create a shell wrapper script named wrapper in installpath
1582 [[ -z $1 ]] && die "dopamd requires at least one argument" 1314# (defaults to the bindir) to execute target (default of wrapper) by
1583 1315# first optionally setting LD_LIBRARY_PATH to the colon-delimited
1584 use pam || return 0 1316# libpaths followed by optionally changing directory to chdir.
1585
1586 INSDESTTREE=/etc/pam.d \
1587 doins "$@" || die "failed to install $@"
1588}
1589# newpamd <old name> <new name>
1590#
1591# Install pam file <old name> as <new name> in /etc/pam.d
1592newpamd() {
1593 [[ $# -ne 2 ]] && die "newpamd requires two arguements"
1594
1595 use pam || return 0
1596
1597 INSDESTTREE=/etc/pam.d \
1598 newins "$1" "$2" || die "failed to install $1 as $2"
1599}
1600
1601# make a wrapper script ...
1602# NOTE: this was originally games_make_wrapper, but I noticed other places where
1603# this could be used, so I have moved it here and made it not games-specific
1604# -- wolf31o2
1605# $1 == wrapper name
1606# $2 == binary to run
1607# $3 == directory to chdir before running binary
1608# $4 == extra LD_LIBRARY_PATH's (make it : delimited)
1609# $5 == path for wrapper
1610make_wrapper() { 1317make_wrapper() {
1611 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5 1318 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5
1612 local tmpwrapper=$(emktemp) 1319 local tmpwrapper=$(emktemp)
1320
1321 (
1322 echo '#!/bin/sh'
1323 [[ -n ${chdir} ]] && printf 'cd "%s"\n' "${chdir}"
1324 if [[ -n ${libdir} ]] ; then
1325 cat <<-EOF
1326 if [ "\${LD_LIBRARY_PATH+set}" = "set" ] ; then
1327 export LD_LIBRARY_PATH="\${LD_LIBRARY_PATH}:${libdir}"
1328 else
1329 export LD_LIBRARY_PATH="${libdir}"
1330 fi
1331 EOF
1332 fi
1613 # We don't want to quote ${bin} so that people can pass complex 1333 # We don't want to quote ${bin} so that people can pass complex
1614 # things as $bin ... "./someprog --args" 1334 # things as ${bin} ... "./someprog --args"
1335 printf 'exec %s "$@"\n' "${bin}"
1615 cat << EOF > "${tmpwrapper}" 1336 ) > "${tmpwrapper}"
1616#!/bin/sh
1617cd "${chdir:-.}"
1618if [ "\${LD_LIBRARY_PATH+set}" = "set" ] && [ -n "${libdir}" ] ; then
1619 export LD_LIBRARY_PATH="\${LD_LIBRARY_PATH}:${libdir}"
1620fi
1621exec ${bin} "\$@"
1622EOF
1623 chmod go+rx "${tmpwrapper}" 1337 chmod go+rx "${tmpwrapper}"
1338
1624 if [[ -n ${path} ]] ; then 1339 if [[ -n ${path} ]] ; then
1340 (
1625 exeinto "${path}" 1341 exeinto "${path}"
1626 newexe "${tmpwrapper}" "${wrapper}" 1342 newexe "${tmpwrapper}" "${wrapper}"
1343 ) || die
1627 else 1344 else
1628 newbin "${tmpwrapper}" "${wrapper}" 1345 newbin "${tmpwrapper}" "${wrapper}" || die
1346 fi
1347}
1348
1349# @FUNCTION: path_exists
1350# @USAGE: [-a|-o] <paths>
1351# @DESCRIPTION:
1352# Check if the specified paths exist. Works for all types of paths
1353# (files/dirs/etc...). The -a and -o flags control the requirements
1354# of the paths. They correspond to "and" and "or" logic. So the -a
1355# flag means all the paths must exist while the -o flag means at least
1356# one of the paths must exist. The default behavior is "and". If no
1357# paths are specified, then the return value is "false".
1358path_exists() {
1359 local opt=$1
1360 [[ ${opt} == -[ao] ]] && shift || opt="-a"
1361
1362 # no paths -> return false
1363 # same behavior as: [[ -e "" ]]
1364 [[ $# -eq 0 ]] && return 1
1365
1366 local p r=0
1367 for p in "$@" ; do
1368 [[ -e ${p} ]]
1369 : $(( r += $? ))
1370 done
1371
1372 case ${opt} in
1373 -a) return $(( r != 0 )) ;;
1374 -o) return $(( r == $# )) ;;
1375 esac
1376}
1377
1378# @FUNCTION: in_iuse
1379# @USAGE: <flag>
1380# @DESCRIPTION:
1381# Determines whether the given flag is in IUSE. Strips IUSE default prefixes
1382# as necessary.
1383#
1384# Note that this function should not be used in the global scope.
1385in_iuse() {
1386 debug-print-function ${FUNCNAME} "${@}"
1387 [[ ${#} -eq 1 ]] || die "Invalid args to ${FUNCNAME}()"
1388
1389 local flag=${1}
1390 local liuse=( ${IUSE} )
1391
1392 has "${flag}" "${liuse[@]#[+-]}"
1393}
1394
1395# @FUNCTION: use_if_iuse
1396# @USAGE: <flag>
1397# @DESCRIPTION:
1398# Return true if the given flag is in USE and IUSE.
1399#
1400# Note that this function should not be used in the global scope.
1401use_if_iuse() {
1402 in_iuse $1 || return 1
1403 use $1
1404}
1405
1406# @FUNCTION: usex
1407# @USAGE: <USE flag> [true output] [false output] [true suffix] [false suffix]
1408# @DESCRIPTION:
1409# Proxy to declare usex for package managers or EAPIs that do not provide it
1410# and use the package manager implementation when available (i.e. EAPI >= 5).
1411# If USE flag is set, echo [true output][true suffix] (defaults to "yes"),
1412# otherwise echo [false output][false suffix] (defaults to "no").
1413if has "${EAPI:-0}" 0 1 2 3 4; then
1414 usex() { use "$1" && echo "${2-yes}$4" || echo "${3-no}$5" ; } #382963
1415fi
1416
1417# @FUNCTION: prune_libtool_files
1418# @USAGE: [--all|--modules]
1419# @DESCRIPTION:
1420# Locate unnecessary libtool files (.la) and libtool static archives
1421# (.a) and remove them from installation image.
1422#
1423# By default, .la files are removed whenever the static linkage can
1424# either be performed using pkg-config or doesn't introduce additional
1425# flags.
1426#
1427# If '--modules' argument is passed, .la files for modules (plugins) are
1428# removed as well. This is usually useful when the package installs
1429# plugins and the plugin loader does not use .la files.
1430#
1431# If '--all' argument is passed, all .la files are removed without
1432# performing any heuristic on them. You shouldn't ever use that,
1433# and instead report a bug in the algorithm instead.
1434#
1435# The .a files are only removed whenever corresponding .la files state
1436# that they should not be linked to, i.e. whenever these files
1437# correspond to plugins.
1438#
1439# Note: if your package installs both static libraries and .pc files
1440# which use variable substitution for -l flags, you need to add
1441# pkg-config to your DEPEND.
1442prune_libtool_files() {
1443 debug-print-function ${FUNCNAME} "$@"
1444
1445 local removing_all removing_modules opt
1446 for opt; do
1447 case "${opt}" in
1448 --all)
1449 removing_all=1
1450 removing_modules=1
1451 ;;
1452 --modules)
1453 removing_modules=1
1454 ;;
1455 *)
1456 die "Invalid argument to ${FUNCNAME}(): ${opt}"
1457 esac
1458 done
1459
1460 local f
1461 local queue=()
1462 while IFS= read -r -d '' f; do # for all .la files
1463 local archivefile=${f/%.la/.a}
1464
1465 # The following check is done by libtool itself.
1466 # It helps us avoid removing random files which match '*.la',
1467 # see bug #468380.
1468 if ! sed -n -e '/^# Generated by .*libtool/q0;4q1' "${f}"; then
1469 continue
1629 fi 1470 fi
1471
1472 [[ ${f} != ${archivefile} ]] || die 'regex sanity check failed'
1473 local reason pkgconfig_scanned
1474 local snotlink=$(sed -n -e 's:^shouldnotlink=::p' "${f}")
1475
1476 if [[ ${snotlink} == yes ]]; then
1477
1478 # Remove static libs we're not supposed to link against.
1479 if [[ -f ${archivefile} ]]; then
1480 einfo "Removing unnecessary ${archivefile#${D%/}} (static plugin)"
1481 queue+=( "${archivefile}" )
1482 fi
1483
1484 # The .la file may be used by a module loader, so avoid removing it
1485 # unless explicitly requested.
1486 if [[ ${removing_modules} ]]; then
1487 reason='module'
1488 fi
1489
1490 else
1491
1492 # Remove .la files when:
1493 # - user explicitly wants us to remove all .la files,
1494 # - respective static archive doesn't exist,
1495 # - they are covered by a .pc file already,
1496 # - they don't provide any new information (no libs & no flags).
1497
1498 if [[ ${removing_all} ]]; then
1499 reason='requested'
1500 elif [[ ! -f ${archivefile} ]]; then
1501 reason='no static archive'
1502 elif [[ ! $(sed -nre \
1503 "s/^(dependency_libs|inherited_linker_flags)='(.*)'$/\2/p" \
1504 "${f}") ]]; then
1505 reason='no libs & flags'
1506 else
1507 if [[ ! ${pkgconfig_scanned} ]]; then
1508 # Create a list of all .pc-covered libs.
1509 local pc_libs=()
1510 if [[ ! ${removing_all} ]]; then
1511 local pc
1512 local tf=${T}/prune-lt-files.pc
1513 local pkgconf=$(tc-getPKG_CONFIG)
1514
1515 while IFS= read -r -d '' pc; do # for all .pc files
1516 local arg libs
1517
1518 # Use pkg-config if available (and works),
1519 # fallback to sed.
1520 if ${pkgconf} --exists "${pc}" &>/dev/null; then
1521 sed -e '/^Requires:/d' "${pc}" > "${tf}"
1522 libs=$(${pkgconf} --libs "${tf}")
1523 else
1524 libs=$(sed -ne 's/^Libs://p' "${pc}")
1525 fi
1526
1527 for arg in ${libs}; do
1528 if [[ ${arg} == -l* ]]; then
1529 if [[ ${arg} == '*$*' ]]; then
1530 eqawarn "${FUNCNAME}: variable substitution likely failed in ${pc}"
1531 eqawarn "(arg: ${arg})"
1532 eqawarn "Most likely, you need to add virtual/pkgconfig to DEPEND."
1533 fi
1534
1535 pc_libs+=( lib${arg#-l}.la )
1536 fi
1537 done
1538 done < <(find "${D}" -type f -name '*.pc' -print0)
1539
1540 rm -f "${tf}"
1541 fi
1542
1543 pkgconfig_scanned=1
1544 fi # pkgconfig_scanned
1545
1546 has "${f##*/}" "${pc_libs[@]}" && reason='covered by .pc'
1547 fi # removal due to .pc
1548
1549 fi # shouldnotlink==no
1550
1551 if [[ ${reason} ]]; then
1552 einfo "Removing unnecessary ${f#${D%/}} (${reason})"
1553 queue+=( "${f}" )
1554 fi
1555 done < <(find "${D}" -xtype f -name '*.la' -print0)
1556
1557 if [[ ${queue[@]} ]]; then
1558 rm -f "${queue[@]}"
1559 fi
1630} 1560}
1561
1562check_license() { die "you no longer need this as portage supports ACCEPT_LICENSE itself"; }
1563
1564fi

Legend:
Removed from v.1.206  
changed lines
  Added in v.1.421

  ViewVC Help
Powered by ViewVC 1.1.20